"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Limiter = exports.stringToArgv = exports.confirmPrompt = exports.toPromise = exports.formatTime = exports.showArgsHelp = exports.parseArgs = exports.stringify = exports.Colors = void 0;
var deepmerge = require("deepmerge");
var elements_1 = require("prompts/lib/elements");
var Colors;
(function (Colors) {
    Colors["Red"] = "\u001B[31m";
    Colors["Green"] = "\u001B[32m";
    Colors["Yellow"] = "\u001B[33m";
    Colors["Blue"] = "\u001B[94m";
    Colors["Cyan"] = "\u001B[36m";
    Colors["Bold"] = "\u001B[1m";
    Colors["Dim"] = "\u001B[2m";
    Colors["Normal"] = "\u001B[0m";
})(Colors = exports.Colors || (exports.Colors = {}));
function stringify(value, replacer, space) {
    if (space === void 0) { space = 2; }
    if (typeof value !== 'string') {
        value = JSON.stringify(value, replacer, space);
    }
    return value.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
        var cls = Colors.Yellow;
        if (/^"/.test(match)) {
            if (/:$/.test(match)) {
                cls = Colors.Normal;
            }
            else {
                cls = Colors.Green;
            }
        }
        else if (/true|false/.test(match)) {
            cls = Colors.Yellow;
        }
        else if (/null/.test(match)) {
            cls = Colors.Dim;
        }
        return cls + match + Colors.Normal;
    });
}
exports.stringify = stringify;
function parseArgs(argv, defaultData) {
    var e_1, _a;
    if (defaultData === void 0) { defaultData = null; }
    var result = {
        arguments: {},
        optionals: [],
        unknowns: []
    };
    defaultData = defaultData instanceof Function ? defaultData() : defaultData;
    var validArguments = Object.keys(defaultData.arguments);
    var commandFound = false;
    try {
        for (var argv_1 = __values(argv), argv_1_1 = argv_1.next(); !argv_1_1.done; argv_1_1 = argv_1.next()) {
            var arg = argv_1_1.value;
            if (arg === '--')
                break;
            var columns = arg.split('=', 2);
            var name = columns[0].replace(/^--/, '');
            var value = true;
            if (columns.length > 1) {
                if (name === columns[0])
                    throw new Error('Unexpected value for command ("' + name + '") use option syntax instead ("--' + name + '=' + columns[1] + '").');
                if (!validArguments.includes(name))
                    throw new Error('The specified option ("--' + name + '") is invalid.');
                value = Number.parseInt(columns[1], 10);
                if (isNaN(value))
                    value = columns[1];
                if (columns[1] === 'true' || columns[1] === 'false')
                    value = columns[1] === 'true';
                var defaultArgument = defaultData.arguments[name];
                if (defaultArgument !== null && defaultArgument !== undefined && typeof defaultData.arguments[name] !== typeof value) {
                    throw new Error('Unexpected type "' + typeof value + '" for argument "' + name + '". The argument should be of type "' + typeof defaultData[name] + '".');
                }
            }
            else {
                if (!commandFound) {
                    if (!validArguments.includes(name)) {
                        result.unknowns.push(name);
                        continue;
                    }
                    if (!columns[0].startsWith('--'))
                        commandFound = true;
                }
                else {
                    result.optionals.push(name);
                    continue;
                }
            }
            result.arguments[name] = value;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (argv_1_1 && !argv_1_1.done && (_a = argv_1.return)) _a.call(argv_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (result !== null) {
        if (defaultData === null)
            return result;
        if (defaultData instanceof Function)
            return result;
        if (typeof defaultData === 'string')
            return result;
        if (defaultData instanceof String)
            return result;
        return deepmerge(defaultData, result);
    }
    return defaultData;
}
exports.parseArgs = parseArgs;
function showArgsHelp(name, descriptions) {
    var e_2, _a, e_3, _b;
    console.log('Usage: ' + name + ' [command] [options...]');
    try {
        for (var _c = __values(Object.values(descriptions)), _d = _c.next(); !_d.done; _d = _c.next()) {
            var description = _d.value;
            if (!description)
                continue;
            if (Array.isArray(description)) {
                try {
                    for (var _e = (e_3 = void 0, __values(Object.values(description))), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var item = _f.value;
                        console.log(item);
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
            }
            else {
                console.log(description);
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_2) throw e_2.error; }
    }
}
exports.showArgsHelp = showArgsHelp;
function formatTime(time, timezoneOffset) {
    if (time === void 0) { time = Date.now(); }
    if (timezoneOffset === void 0) { timezoneOffset = new Date().getTimezoneOffset() * -60000; }
    return new Date(time + timezoneOffset).toISOString().replace('T', ' ').replace('Z', '');
}
exports.formatTime = formatTime;
function toPromise(prompt, options) {
    if (options === void 0) { options = {}; }
    var dummyHandler = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return args;
    };
    var onState = options.onState || dummyHandler;
    var onAbort = options.onAbort || dummyHandler;
    var onSubmit = options.onSubmit || dummyHandler;
    return new Promise(function (resolve, reject) {
        prompt.on('state', onState);
        prompt.on('submit', function (args) { return resolve(onSubmit(args)); });
        prompt.on('abort', function (args) { return reject(onAbort(args)); });
    });
}
exports.toPromise = toPromise;
function confirmPrompt(message, autoValue, defaultValue) {
    if (defaultValue === void 0) { defaultValue = false; }
    return __awaiter(this, void 0, void 0, function () {
        var confirmPrompt, confirmPromise, choice;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    confirmPrompt = new elements_1.ConfirmPrompt({
                        type: 'confirm',
                        name: 'value',
                        initial: autoValue !== undefined ? autoValue : defaultValue,
                        message: message
                    });
                    confirmPromise = toPromise(confirmPrompt);
                    if (autoValue !== undefined)
                        confirmPrompt.submit();
                    return [4 /*yield*/, confirmPromise];
                case 1:
                    choice = _a.sent();
                    return [2 /*return*/, choice[0]];
            }
        });
    });
}
exports.confirmPrompt = confirmPrompt;
function stringToArgv(value) {
    var result = [];
    var spaces = '\t ';
    var quotes = '"\'';
    var start = 0;
    var index = 0;
    function scanSpace() {
        if (!(spaces + quotes).includes(value[index])) {
            start = index;
            while (index < value.length && !(spaces + quotes).includes(value[index]))
                index++;
            return value.substr(start, index - start);
        }
        return null;
    }
    function scanQuote() {
        if (value[index] === "'") {
            start = ++index;
            while (index < value.length && value[index] !== "'")
                index++;
            return value.substr(start, index++ - start);
        }
        if (value[index] === '"') {
            start = ++index;
            while (index < value.length && value[index] !== '"')
                index++;
            return value.substr(start, index++ - start);
        }
        return null;
    }
    var param = null;
    while (index < value.length) {
        if (!spaces.includes(value[index])) {
            if (param === null)
                param = '';
            var quoteParam = scanQuote();
            if (quoteParam !== null) {
                param += quoteParam;
                continue;
            }
            var spaceParam = scanSpace();
            if (spaceParam !== null) {
                param += spaceParam;
                continue;
            }
        }
        if (param !== null) {
            result.push(param);
            param = null;
        }
        index++;
    }
    if (param !== null) {
        result.push(param);
        param = null;
    }
    return result;
}
exports.stringToArgv = stringToArgv;
var Limiter = /** @class */ (function () {
    function Limiter(maximum) {
        this.currentCount = 0;
        this.maximumCount = maximum;
        this.resolvers = [];
    }
    Limiter.prototype.enter = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        if (_this.currentCount < _this.maximumCount) {
                            _this.currentCount++;
                            resolve(_this.currentCount);
                            return;
                        }
                        _this.resolvers.push(resolve);
                    })];
            });
        });
    };
    Limiter.prototype.leave = function () {
        this.currentCount--;
        while (this.currentCount < this.maximumCount && this.resolvers.length > 0) {
            var resolver = this.resolvers[0];
            this.resolvers.shift();
            this.currentCount++;
            resolver(this.currentCount);
        }
        return this.currentCount;
    };
    return Limiter;
}());
exports.Limiter = Limiter;
