"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Executor = void 0;
var scripts_1 = require("./scripts");
var spawn_process_1 = require("./spawn-process");
var fs = require("fs");
var path = require("path");
var logger_1 = require("./logger");
var common_1 = require("./common");
var glob = require("fast-glob");
var prettyTime = require("pretty-time");
var variables_1 = require("./variables");
var url_1 = require("url");
var Order;
(function (Order) {
    Order[Order["concurrent"] = 0] = "concurrent";
    Order[Order["sequential"] = 1] = "sequential";
})(Order || (Order = {}));
var Executor = /** @class */ (function () {
    function Executor(shell, environment, settings, scripts, globOptions, confirm, limit, testmode) {
        this.shell = shell;
        this.environment = environment;
        this.settings = settings;
        this.scripts = scripts;
        this.globOptions = globOptions;
        this.confirm = confirm;
        this.testmode = testmode;
        this.startTime = process.hrtime();
        this.limit = limit;
    }
    Executor.prototype.execute = function (scriptInfo) {
        return __awaiter(this, void 0, void 0, function () {
            var tasks, options, settings, settings_1, settings_1_1, _a, key, value, _b, _c, _d, key, value, processes, concurrent, sequential, _e, _f, _g, _h, _j, _k, _l, _m, _o;
            var e_1, _p, e_2, _q;
            return __generator(this, function (_r) {
                switch (_r.label) {
                    case 0:
                        tasks = this.expand(scriptInfo);
                        options = {
                            stdio: 'inherit',
                            env: this.environment,
                            shell: this.shell,
                            suppress: false,
                            testmode: this.testmode,
                            limit: this.limit
                        };
                        if (logger_1.Logger.level > 0) {
                            logger_1.Logger.info('Script id       :', scriptInfo.name);
                            logger_1.Logger.info('Circular        :', Executor.isCircular([tasks]));
                            logger_1.Logger.info('Script params   :', scriptInfo.parameters);
                            logger_1.Logger.info('Script args     :', scriptInfo.arguments);
                            logger_1.Logger.debug('Script object   : ' + (0, common_1.stringify)(scriptInfo.script));
                            logger_1.Logger.debug('Script expanded : ' + (0, common_1.stringify)(tasks, Executor.removeEmpties));
                            logger_1.Logger.info();
                            logger_1.Logger.log();
                        }
                        if (logger_1.Logger.level > 1) {
                            settings = Object.entries(this.environment).filter(function (_a) {
                                var _b = __read(_a, 2), key = _b[0], value = _b[1];
                                return key.startsWith('launch_setting_');
                            });
                            logger_1.Logger.log(common_1.Colors.Bold + 'Launcher Settings Values' + common_1.Colors.Normal);
                            logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                            try {
                                for (settings_1 = __values(settings), settings_1_1 = settings_1.next(); !settings_1_1.done; settings_1_1 = settings_1.next()) {
                                    _a = __read(settings_1_1.value, 2), key = _a[0], value = _a[1];
                                    logger_1.Logger.log(common_1.Colors.Dim + key + common_1.Colors.Normal + '=' + common_1.Colors.Green + "'" + value + "'" + common_1.Colors.Normal);
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (settings_1_1 && !settings_1_1.done && (_p = settings_1.return)) _p.call(settings_1);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                            logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                            logger_1.Logger.log('Total: ' + settings.length);
                            logger_1.Logger.log();
                            logger_1.Logger.log();
                            logger_1.Logger.log(common_1.Colors.Bold + 'Launcher Settings Arrays' + common_1.Colors.Normal);
                            logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                            try {
                                for (_b = __values(Object.entries(this.settings.arrays)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                    _d = __read(_c.value, 2), key = _d[0], value = _d[1];
                                    logger_1.Logger.log(common_1.Colors.Dim + key + common_1.Colors.Normal + '=' + (0, common_1.stringify)(value));
                                }
                            }
                            catch (e_2_1) { e_2 = { error: e_2_1 }; }
                            finally {
                                try {
                                    if (_c && !_c.done && (_q = _b.return)) _q.call(_b);
                                }
                                finally { if (e_2) throw e_2.error; }
                            }
                            logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                            logger_1.Logger.log('Total: ' + settings.length);
                            logger_1.Logger.log();
                            logger_1.Logger.log();
                        }
                        processes = [];
                        concurrent = __spreadArray([], __read(tasks.concurrent), false);
                        sequential = __spreadArray([], __read(tasks.sequential), false);
                        if (!Executor.containsConstraint(tasks)) return [3 /*break*/, 4];
                        _r.label = 1;
                    case 1:
                        _r.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.evaluateTask(tasks, options)];
                    case 2:
                        if (_r.sent()) {
                            concurrent.push.apply(concurrent, __spreadArray([], __read(tasks['concurrent-then']), false));
                            sequential.push.apply(sequential, __spreadArray([], __read(tasks['sequential-then']), false));
                        }
                        else {
                            concurrent.push.apply(concurrent, __spreadArray([], __read(tasks['concurrent-else']), false));
                            sequential.push.apply(sequential, __spreadArray([], __read(tasks['sequential-else']), false));
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        _e = _r.sent();
                        return [2 /*return*/, 0];
                    case 4:
                        _g = (_f = processes.push).apply;
                        _h = [processes];
                        _j = [[]];
                        return [4 /*yield*/, this.executeTasks(concurrent, options, Order.concurrent, process.hrtime())];
                    case 5:
                        _g.apply(_f, _h.concat([__spreadArray.apply(void 0, _j.concat([__read.apply(void 0, [(_r.sent())]), false]))]));
                        _l = (_k = processes.push).apply;
                        _m = [processes];
                        _o = [[]];
                        return [4 /*yield*/, this.executeTasks(sequential, options, Order.sequential, process.hrtime())];
                    case 6:
                        _l.apply(_k, _m.concat([__spreadArray.apply(void 0, _o.concat([__read.apply(void 0, [(_r.sent())]), false]))]));
                        return [2 /*return*/, Executor.wait(processes)];
                }
            });
        });
    };
    Executor.isEmptyTask = function (tasks) {
        if (tasks.confirm.length > 0)
            return false;
        if (tasks.condition.length > 0)
            return false;
        if (tasks.exclusion.length > 0)
            return false;
        if (tasks.concurrent.length > 0)
            return false;
        if (tasks.sequential.length > 0)
            return false;
        if (tasks['concurrent-then'].length > 0)
            return false;
        if (tasks['sequential-then'].length > 0)
            return false;
        if (tasks['concurrent-else'].length > 0)
            return false;
        if (tasks['sequential-else'].length > 0)
            return false;
        return true;
    };
    Executor.convertSingleQuote = function (command) {
        var e_3, _a;
        var argv = (0, common_1.stringToArgv)(command);
        var result = [];
        try {
            for (var argv_1 = __values(argv), argv_1_1 = argv_1.next(); !argv_1_1.done; argv_1_1 = argv_1.next()) {
                var value = argv_1_1.value;
                if (value.includes(' '))
                    value = '"' + value + '"';
                result.push(value);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (argv_1_1 && !argv_1_1.done && (_a = argv_1.return)) _a.call(argv_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return result.join(' ');
    };
    Executor.removeEmpties = function (key, value) {
        if (value instanceof Array && value.length === 0)
            return undefined;
        return value;
    };
    Executor.containsConstraint = function (task) {
        return task.condition.length > 0 || task.exclusion.length > 0 || task.confirm.length > 0;
    };
    Executor.expandArguments = function (text, args) {
        var variables = [];
        for (var index = 0; index < args.length; index++) {
            variables.push([index + '\\*', args.slice(index).join(' ')]);
            variables.push([index.toString(), args[index]]);
        }
        variables.push(['\\*', args.slice(1).join(' ')]);
        text = variables_1.Variables.expand(text, variables);
        return variables_1.Variables.remove(text, '\\d+');
    };
    Executor.expandEnvironment = function (text, environment) {
        return variables_1.Variables.expand(text, Object.entries(environment));
    };
    Executor.removeEnvironment = function (text) {
        return variables_1.Variables.remove(text, '\\w+');
    };
    Executor.extendEnvironment = function (environment, command) {
        var e_4, _a;
        var match = command.trim().match(Executor.assignmentPattern);
        if (match !== null) {
            if (match[2].startsWith('$')) {
                var environmentValue_1 = match[2].replace('$', '');
                var settings = Object.entries(environment).filter(function (_a) {
                    var _b = __read(_a, 1), key = _b[0];
                    return key.startsWith(environmentValue_1 + '_');
                });
                try {
                    for (var settings_2 = __values(settings), settings_2_1 = settings_2.next(); !settings_2_1.done; settings_2_1 = settings_2.next()) {
                        var _b = __read(settings_2_1.value, 2), key = _b[0], value = _b[1];
                        if (key.startsWith(environmentValue_1)) {
                            var environmentKey = match[1] + key.replace(environmentValue_1, '');
                            environment[environmentKey] = value;
                            logger_1.Logger.debug(common_1.Colors.Bold + 'Set environment' + common_1.Colors.Normal + ' : ' + common_1.Colors.Green + "'" + environmentKey + '=' + value + "'" + common_1.Colors.Normal);
                        }
                    }
                }
                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                finally {
                    try {
                        if (settings_2_1 && !settings_2_1.done && (_a = settings_2.return)) _a.call(settings_2);
                    }
                    finally { if (e_4) throw e_4.error; }
                }
            }
            else {
                environment[match[1]] = match[2];
                logger_1.Logger.debug(common_1.Colors.Bold + 'Set environment' + common_1.Colors.Normal + ' : ' + common_1.Colors.Green + "'" + match[1] + '=' + match[2] + "'" + common_1.Colors.Normal);
            }
            return true;
        }
        return false;
    };
    Executor.isDynamicPattern = function (item, options) {
        if (!item || item.match(/^['|"].*['|"]$/) !== null)
            return false;
        return glob.isDynamicPattern(item.replace(/\\./g, ''), options);
    };
    Executor.splitString = function (value) {
        var result = [];
        var last = 0;
        var index = 0;
        while (index < value.length) {
            var char = value[index];
            if (char === ' ') {
                result.push(value.substr(last, index - last));
                last = index + 1;
            }
            if (char === '"') {
                while (++index < value.length && value[index] !== '"')
                    ;
            }
            if (char === "'") {
                while (++index < value.length && value[index] !== "'")
                    ;
            }
            index++;
        }
        result.push(value.substr(last, index - last));
        return result;
    };
    Executor.expandGlobs = function (pattern, options) {
        var e_5, _a;
        var result = [];
        try {
            for (var _b = __values(Executor.splitString(pattern)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var item = _c.value;
                var value = [item];
                if (Executor.isDynamicPattern(item, options)) {
                    value = glob.sync(item, options);
                    if (options.nonull && value.length === 0)
                        value = [item];
                }
                result.push.apply(result, __spreadArray([], __read(value), false));
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_5) throw e_5.error; }
        }
        return result.join(' ');
    };
    Executor.getCommandInfo = function (command, options) {
        if (!command)
            command = '';
        options = __assign({}, options);
        options.env = __assign({}, options.env);
        command = Executor.expandEnvironment(command, options.env);
        if (!options.cwd)
            options.cwd = '';
        var args = [];
        if (!options.shell) {
            args = (0, common_1.stringToArgv)(command);
            command = args[0];
            args.shift();
        }
        if (command === '') {
            console.log();
            return { command: null, args: args, options: options };
        }
        if (command === 'echo') {
            if (process.platform === 'win32')
                command += '.';
            return { command: command, args: args, options: options };
        }
        if (command === '--') {
            if (options.testmode) {
                console.log(''.padEnd(32, '-'));
            }
            else {
                console.log(''.padEnd(process.stdout.columns, '-'));
            }
            return { command: null, args: args, options: options };
        }
        if (command.startsWith('#')) {
            logger_1.Logger.log(common_1.Colors.Bold + 'Skipping action' + common_1.Colors.Normal + ' : ' + common_1.Colors.Green + "'" + command + "'" + common_1.Colors.Normal, args);
            return { command: null, args: args, options: options };
        }
        if (command.endsWith(' || true')) {
            command = command.replace(/ \|\| true$/, '');
            options.suppress = true;
        }
        if (Executor.extendEnvironment(options.env, command))
            return { command: null, args: args, options: options };
        if (options.cwd instanceof url_1.URL) {
            throw new Error('A directory type of type URL is not supported.');
        }
        var fullPath = path.join(path.resolve(options.cwd), command);
        if (fs.existsSync(fullPath)) {
            options.cwd = fullPath;
            return { command: null, args: args, options: options };
        }
        return { command: command, args: args, options: options };
    };
    Executor.wait = function (processes) {
        return __awaiter(this, void 0, void 0, function () {
            var exitCode, processes_1, processes_1_1, item, _a, _b, _c, e_6_1;
            var e_6, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        exitCode = 0;
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 9, 10, 11]);
                        processes_1 = __values(processes), processes_1_1 = processes_1.next();
                        _e.label = 2;
                    case 2:
                        if (!!processes_1_1.done) return [3 /*break*/, 8];
                        item = processes_1_1.value;
                        if (!(item instanceof Promise)) return [3 /*break*/, 5];
                        _a = exitCode;
                        _b = this.wait;
                        return [4 /*yield*/, item];
                    case 3: return [4 /*yield*/, _b.apply(this, [_e.sent()])];
                    case 4:
                        exitCode = _a + _e.sent();
                        return [3 /*break*/, 7];
                    case 5:
                        _c = exitCode;
                        return [4 /*yield*/, item.wait()];
                    case 6:
                        exitCode = _c + _e.sent();
                        _e.label = 7;
                    case 7:
                        processes_1_1 = processes_1.next();
                        return [3 /*break*/, 2];
                    case 8: return [3 /*break*/, 11];
                    case 9:
                        e_6_1 = _e.sent();
                        e_6 = { error: e_6_1 };
                        return [3 /*break*/, 11];
                    case 10:
                        try {
                            if (processes_1_1 && !processes_1_1.done && (_d = processes_1.return)) _d.call(processes_1);
                        }
                        finally { if (e_6) throw e_6.error; }
                        return [7 /*endfinally*/];
                    case 11: return [2 /*return*/, exitCode];
                }
            });
        });
    };
    Executor.isCircular = function (tasks) {
        var e_7, _a;
        try {
            for (var tasks_1 = __values(tasks), tasks_1_1 = tasks_1.next(); !tasks_1_1.done; tasks_1_1 = tasks_1.next()) {
                var task = tasks_1_1.value;
                if (typeof task !== 'string') {
                    if (task.circular)
                        return true;
                    if (Executor.isCircular(task.concurrent))
                        return true;
                    if (Executor.isCircular(task.sequential))
                        return true;
                    if (Executor.isCircular(task['concurrent-then']))
                        return true;
                    if (Executor.isCircular(task['sequential-then']))
                        return true;
                    if (Executor.isCircular(task['concurrent-else']))
                        return true;
                    if (Executor.isCircular(task['sequential-else']))
                        return true;
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (tasks_1_1 && !tasks_1_1.done && (_a = tasks_1.return)) _a.call(tasks_1);
            }
            finally { if (e_7) throw e_7.error; }
        }
        return false;
    };
    Executor.prototype.preprocessScripts = function (scripts) {
        var result = [];
        if (scripts) {
            if (typeof scripts !== 'string') {
                result.push.apply(result, __spreadArray([], __read(scripts), false));
            }
            else {
                result.push(scripts);
            }
        }
        return result;
    };
    Executor.prototype.expand = function (scriptInfo, parents) {
        var e_8, _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, e_9, _m;
        if (parents === void 0) { parents = []; }
        var script = scriptInfo.script;
        var repeater = script.repeater;
        var result = {
            'circular': false,
            'parameters': {},
            'confirm': [],
            'condition': [],
            'exclusion': [],
            'concurrent': [],
            'sequential': [],
            'concurrent-then': [],
            'sequential-then': [],
            'concurrent-else': [],
            'sequential-else': []
        };
        var environment = __assign(__assign({}, scriptInfo.parameters), this.settings.values);
        try {
            for (var _o = __values(Object.entries(scriptInfo.parameters)), _p = _o.next(); !_p.done; _p = _o.next()) {
                var _q = __read(_p.value, 2), name = _q[0], value = _q[1];
                if (value === undefined) {
                    throw new Error('The parameter "' + name + '" of script "' + scriptInfo.name + '" is ' + value + '.');
                }
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_p && !_p.done && (_a = _o.return)) _a.call(_o);
            }
            finally { if (e_8) throw e_8.error; }
        }
        if (!repeater) {
            var confirm = [];
            var concurrent = [];
            var sequential = [];
            var concurrentThen = [];
            var sequentialThen = [];
            var concurrentElse = [];
            var sequentialElse = [];
            if (script instanceof Array)
                (_b = (scriptInfo.inline ? concurrent : sequential)).push.apply(_b, __spreadArray([], __read(script), false));
            if (typeof script === 'string')
                sequential.push(script);
            parents = __spreadArray(__spreadArray([], __read(parents), false), [scriptInfo.name], false);
            confirm.push.apply(confirm, __spreadArray([], __read(this.preprocessScripts(script.confirm)), false));
            concurrent.push.apply(concurrent, __spreadArray([], __read(this.preprocessScripts(script.concurrent)), false));
            sequential.push.apply(sequential, __spreadArray([], __read(this.preprocessScripts(script.sequential)), false));
            concurrentThen.push.apply(concurrentThen, __spreadArray([], __read(this.preprocessScripts(script['concurrent-then'])), false));
            sequentialThen.push.apply(sequentialThen, __spreadArray([], __read(this.preprocessScripts(script['sequential-then'])), false));
            concurrentElse.push.apply(concurrentElse, __spreadArray([], __read(this.preprocessScripts(script['concurrent-else'])), false));
            sequentialElse.push.apply(sequentialElse, __spreadArray([], __read(this.preprocessScripts(script['sequential-else'])), false));
            result.parameters = scriptInfo.parameters;
            (_c = result.confirm).push.apply(_c, __spreadArray([], __read(this.expandConstraint(parents, script.confirm, environment, scriptInfo.arguments, result)), false));
            (_d = result.condition).push.apply(_d, __spreadArray([], __read(this.expandConstraint(parents, script.condition, environment, scriptInfo.arguments, result)), false));
            (_e = result.exclusion).push.apply(_e, __spreadArray([], __read(this.expandConstraint(parents, script.exclusion, environment, scriptInfo.arguments, result)), false));
            (_f = result.concurrent).push.apply(_f, __spreadArray([], __read(this.expandTasks(parents, concurrent, environment, scriptInfo.arguments, scriptInfo.parameters, result)), false));
            (_g = result.sequential).push.apply(_g, __spreadArray([], __read(this.expandTasks(parents, sequential, environment, scriptInfo.arguments, scriptInfo.parameters, result)), false));
            (_h = result['concurrent-then']).push.apply(_h, __spreadArray([], __read(this.expandTasks(parents, concurrentThen, environment, scriptInfo.arguments, scriptInfo.parameters, result)), false));
            (_j = result['sequential-then']).push.apply(_j, __spreadArray([], __read(this.expandTasks(parents, sequentialThen, environment, scriptInfo.arguments, scriptInfo.parameters, result)), false));
            (_k = result['concurrent-else']).push.apply(_k, __spreadArray([], __read(this.expandTasks(parents, concurrentElse, environment, scriptInfo.arguments, scriptInfo.parameters, result)), false));
            (_l = result['sequential-else']).push.apply(_l, __spreadArray([], __read(this.expandTasks(parents, sequentialElse, environment, scriptInfo.arguments, scriptInfo.parameters, result)), false));
        }
        else {
            var array = repeater.replace(/^\$/, '');
            array = Executor.expandArguments(array, scriptInfo.arguments);
            array = Executor.expandEnvironment(array, environment);
            var settings = this.settings.arrays[array] || [];
            var repeaterTask = {
                name: scriptInfo.name,
                inline: scriptInfo.inline,
                multiple: false,
                parameters: null,
                arguments: scriptInfo.arguments,
                script: __assign({}, scriptInfo.script)
            };
            repeaterTask.script.repeater = null;
            try {
                for (var settings_3 = __values(settings), settings_3_1 = settings_3.next(); !settings_3_1.done; settings_3_1 = settings_3.next()) {
                    var setting = settings_3_1.value;
                    repeaterTask.parameters = __assign(__assign({}, scriptInfo.parameters), setting);
                    var task = this.expand(repeaterTask);
                    result.sequential.push({
                        'circular': false,
                        'parameters': repeaterTask.parameters,
                        'confirm': task.confirm,
                        'condition': task.condition,
                        'exclusion': task.exclusion,
                        'concurrent': task.concurrent,
                        'sequential': task.sequential,
                        'concurrent-then': task['concurrent-then'],
                        'sequential-then': task['sequential-then'],
                        'concurrent-else': task['concurrent-else'],
                        'sequential-else': task['sequential-else']
                    });
                }
            }
            catch (e_9_1) { e_9 = { error: e_9_1 }; }
            finally {
                try {
                    if (settings_3_1 && !settings_3_1.done && (_m = settings_3.return)) _m.call(settings_3);
                }
                finally { if (e_9) throw e_9.error; }
            }
        }
        return result;
    };
    Executor.prototype.expandConstraint = function (parents, constraints, environment, args, meta) {
        var e_10, _a, e_11, _b;
        var result = [];
        if (!constraints)
            return result;
        if (typeof constraints === 'string')
            constraints = [constraints];
        if (!(constraints instanceof Array))
            throw new Error('Constraint object value not supported: ' + (0, common_1.stringify)(constraints));
        try {
            for (var constraints_1 = __values(constraints), constraints_1_1 = constraints_1.next(); !constraints_1_1.done; constraints_1_1 = constraints_1.next()) {
                var constraint = constraints_1_1.value;
                constraint = Executor.expandArguments(constraint, args);
                constraint = Executor.expandEnvironment(constraint, environment);
                var scripts = this.scripts.find(constraint);
                var scriptInfo = scripts_1.Scripts.select(scripts, parents, meta);
                if (scriptInfo) {
                    if (scriptInfo.multiple) {
                        try {
                            for (var _c = (e_11 = void 0, __values(scriptInfo.script)), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var script = _d.value;
                                script = Executor.expandArguments(script, args);
                                script = Executor.expandEnvironment(script, environment);
                                result.push(script);
                            }
                        }
                        catch (e_11_1) { e_11 = { error: e_11_1 }; }
                        finally {
                            try {
                                if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                            }
                            finally { if (e_11) throw e_11.error; }
                        }
                        continue;
                    }
                    scriptInfo.arguments = __spreadArray([scriptInfo.name], __read(scriptInfo.arguments), false);
                    result.push.apply(result, __spreadArray([], __read(this.expandConstraint(__spreadArray(__spreadArray([], __read(parents), false), [constraint], false), scriptInfo.script, __assign(__assign({}, this.environment), scriptInfo.parameters), args, meta)), false));
                }
                else {
                    result.push(constraint);
                }
            }
        }
        catch (e_10_1) { e_10 = { error: e_10_1 }; }
        finally {
            try {
                if (constraints_1_1 && !constraints_1_1.done && (_a = constraints_1.return)) _a.call(constraints_1);
            }
            finally { if (e_10) throw e_10.error; }
        }
        return result;
    };
    Executor.prototype.executeTasks = function (tasks, options, order, startTime, limiter) {
        if (limiter === void 0) { limiter = new common_1.Limiter(options.limit); }
        return __awaiter(this, void 0, void 0, function () {
            var processes, suppress, tasks_2, tasks_2_1, task, info, command, commandProcess, exitCode, concurrent, sequential, _a, concurrentProcesses, sequentialProcesses, exitCode, _b, _c, _d, _e, _f, _g, e_12_1;
            var e_12, _h;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        processes = [];
                        suppress = options.suppress;
                        _j.label = 1;
                    case 1:
                        _j.trys.push([1, 18, 19, 20]);
                        tasks_2 = __values(tasks), tasks_2_1 = tasks_2.next();
                        _j.label = 2;
                    case 2:
                        if (!!tasks_2_1.done) return [3 /*break*/, 17];
                        task = tasks_2_1.value;
                        options.suppress = suppress;
                        if (!(typeof task === 'string')) return [3 /*break*/, 7];
                        options.env.launch_time_current = (0, common_1.formatTime)();
                        options.env.launch_time_elapsed = prettyTime(process.hrtime(startTime), 'ms');
                        if (options.testmode) {
                            options.env.launch_time_current = (0, common_1.formatTime)(new Date('2019-09-16T12:33:42.285').getTime(), 0);
                            options.env.launch_time_elapsed = '137ms';
                        }
                        info = Executor.getCommandInfo(task, options);
                        options = info.options;
                        if (!info.command) return [3 /*break*/, 6];
                        if (options.cwd instanceof url_1.URL) {
                            throw new Error('A directory type of type URL is not supported.');
                        }
                        command = Executor.expandGlobs(info.command, __assign(__assign({}, this.globOptions), { cwd: options.cwd }));
                        command = Executor.removeEnvironment(command);
                        // Remove environment,argument and glob escapings
                        command = command.replace(/\\(.)/g, '$1');
                        if (process.platform === 'win32') {
                            command = Executor.convertSingleQuote(command);
                            if (command.startsWith('echo'))
                                command = 'echo' + command.replace('echo', '').replace(/^\s*\"(.*)\"\s*$/g, ' $1');
                        }
                        logger_1.Logger.log(common_1.Colors.Bold + 'Spawn action   ' + common_1.Colors.Normal + ' : ' + common_1.Colors.Green + "'" + command + "'" + common_1.Colors.Normal, info.args);
                        logger_1.Logger.log('Spawn options   : { order=' + common_1.Colors.Cyan + Order[order] + common_1.Colors.Normal + ', supress=' + common_1.Colors.Yellow + options.suppress + common_1.Colors.Normal + ' }');
                        return [4 /*yield*/, limiter.enter()];
                    case 3:
                        _j.sent();
                        commandProcess = spawn_process_1.Process.spawn(command, info.args, options);
                        processes.push(commandProcess);
                        if (!(order === Order.sequential)) return [3 /*break*/, 5];
                        return [4 /*yield*/, commandProcess.wait()];
                    case 4:
                        exitCode = _j.sent();
                        limiter.leave();
                        if (exitCode !== 0)
                            return [3 /*break*/, 17];
                        return [3 /*break*/, 6];
                    case 5:
                        commandProcess.wait().then(function () { return limiter.leave(); });
                        _j.label = 6;
                    case 6: return [3 /*break*/, 16];
                    case 7:
                        concurrent = __spreadArray([], __read(task.concurrent), false);
                        sequential = __spreadArray([], __read(task.sequential), false);
                        if (!Executor.containsConstraint(task)) return [3 /*break*/, 11];
                        _j.label = 8;
                    case 8:
                        _j.trys.push([8, 10, , 11]);
                        return [4 /*yield*/, this.evaluateTask(task, options)];
                    case 9:
                        if (_j.sent()) {
                            concurrent.push.apply(concurrent, __spreadArray([], __read(task['concurrent-then']), false));
                            sequential.push.apply(sequential, __spreadArray([], __read(task['sequential-then']), false));
                        }
                        else {
                            concurrent.push.apply(concurrent, __spreadArray([], __read(task['concurrent-else']), false));
                            sequential.push.apply(sequential, __spreadArray([], __read(task['sequential-else']), false));
                        }
                        return [3 /*break*/, 11];
                    case 10:
                        _a = _j.sent();
                        return [2 /*return*/, []];
                    case 11:
                        concurrentProcesses = this.executeTasks(concurrent, options, Order.concurrent, process.hrtime(), limiter);
                        sequentialProcesses = this.executeTasks(sequential, options, Order.sequential, process.hrtime(), limiter);
                        processes.push(concurrentProcesses);
                        processes.push(sequentialProcesses);
                        if (!(order === Order.sequential)) return [3 /*break*/, 16];
                        exitCode = 0;
                        _b = exitCode;
                        _d = (_c = Executor).wait;
                        return [4 /*yield*/, concurrentProcesses];
                    case 12: return [4 /*yield*/, _d.apply(_c, [_j.sent()])];
                    case 13:
                        exitCode = _b + _j.sent();
                        _e = exitCode;
                        _g = (_f = Executor).wait;
                        return [4 /*yield*/, sequentialProcesses];
                    case 14: return [4 /*yield*/, _g.apply(_f, [_j.sent()])];
                    case 15:
                        exitCode = _e + _j.sent();
                        if (exitCode > 0)
                            return [3 /*break*/, 17];
                        _j.label = 16;
                    case 16:
                        tasks_2_1 = tasks_2.next();
                        return [3 /*break*/, 2];
                    case 17: return [3 /*break*/, 20];
                    case 18:
                        e_12_1 = _j.sent();
                        e_12 = { error: e_12_1 };
                        return [3 /*break*/, 20];
                    case 19:
                        try {
                            if (tasks_2_1 && !tasks_2_1.done && (_h = tasks_2.return)) _h.call(tasks_2);
                        }
                        finally { if (e_12) throw e_12.error; }
                        return [7 /*endfinally*/];
                    case 20: return [2 /*return*/, processes];
                }
            });
        });
    };
    Executor.prototype.evaluateConstraint = function (type, command, options, outputPattern) {
        return __awaiter(this, void 0, void 0, function () {
            var result, commandProcess, exitCode, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (outputPattern)
                            logger_1.Logger.log('Grep pattern    : ' + common_1.Colors.Green + "'" + outputPattern + "'" + common_1.Colors.Normal);
                        options = __assign({}, options);
                        command = command.replace(/require\s*\(\s*'\.\//g, "require(process.cwd() + '/");
                        try {
                            result = eval(command);
                            if (typeof result !== 'boolean')
                                throw new Error('type not supported');
                            logger_1.Logger.log(common_1.Colors.Bold + type + '       : ' + common_1.Colors.Normal + common_1.Colors.Green + "'" + command + "'" + common_1.Colors.Normal);
                            logger_1.Logger.log('Result          : ' + result);
                            logger_1.Logger.log();
                            logger_1.Logger.log();
                            return [2 /*return*/, result];
                        }
                        catch (error) {
                            // Not a valid javascript expression, continue
                        }
                        if (process.platform === 'win32') {
                            command = Executor.convertSingleQuote(command);
                            if (command.startsWith('echo'))
                                command = 'echo' + command.replace('echo', '').replace(/^\s*\"(.*)\"\s*$/g, ' $1');
                        }
                        logger_1.Logger.log(common_1.Colors.Bold + type + '       : ' + common_1.Colors.Normal + common_1.Colors.Green + "'" + command + "'" + common_1.Colors.Normal);
                        if (options.cwd instanceof url_1.URL) {
                            throw new Error('A directory type of type URL is not supported.');
                        }
                        if (fs.existsSync(path.join(path.resolve(options.cwd), command))) {
                            logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                            logger_1.Logger.log(common_1.Colors.Dim + 'directory exists' + common_1.Colors.Normal);
                            logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                            logger_1.Logger.log('Result          : true');
                            logger_1.Logger.log();
                            logger_1.Logger.log();
                            return [2 /*return*/, true];
                        }
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        options.stdio = ['inherit', 'pipe', 'pipe'];
                        if (outputPattern) {
                            options.extraLogInfo = function (process) {
                                var matches = (process.stdout + process.stderr).match(outputPattern);
                                return 'grep=' + (matches === null ? 'failed' : 'success');
                            };
                        }
                        commandProcess = spawn_process_1.Process.spawn(command, [], options);
                        return [4 /*yield*/, commandProcess.wait()];
                    case 2:
                        exitCode = _b.sent();
                        if (outputPattern)
                            return [2 /*return*/, (commandProcess.stdout + commandProcess.stderr).match(outputPattern) != null];
                        return [2 /*return*/, exitCode === 0];
                    case 3:
                        _a = _b.sent();
                        return [2 /*return*/, false];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Executor.prototype.evaluateTask = function (task, options) {
        return __awaiter(this, void 0, void 0, function () {
            var condition, exclusion, confirmation, _a, _b, constraint, outputMatches, outputPattern, e_13_1, _c, _d, constraint, outputMatches, outputPattern, e_14_1, _e, _f, confirm, e_15_1;
            var e_13, _g, e_14, _h, e_15, _j;
            return __generator(this, function (_k) {
                switch (_k.label) {
                    case 0:
                        condition = true;
                        exclusion = false;
                        confirmation = !(task.confirm.length > 0);
                        options = __assign({}, options);
                        if (!options.cwd)
                            options.cwd = '';
                        _k.label = 1;
                    case 1:
                        _k.trys.push([1, 6, 7, 8]);
                        _a = __values(task.condition), _b = _a.next();
                        _k.label = 2;
                    case 2:
                        if (!!_b.done) return [3 /*break*/, 5];
                        constraint = _b.value;
                        constraint = Executor.expandEnvironment(constraint, options.env);
                        if (!!Executor.extendEnvironment(options.env, constraint)) return [3 /*break*/, 4];
                        outputMatches = constraint.match(/(.*)\|\?(.*)/);
                        outputPattern = null;
                        if (outputMatches !== null) {
                            constraint = outputMatches[1].trim();
                            outputPattern = Executor.expandEnvironment(outputMatches[2].trim(), options.env);
                            outputPattern = Executor.removeEnvironment(outputPattern);
                        }
                        if (options.cwd instanceof url_1.URL) {
                            throw new Error('A directory type of type URL is not supported.');
                        }
                        constraint = Executor.expandGlobs(constraint, __assign(__assign({}, this.globOptions), { cwd: options.cwd }));
                        constraint = Executor.removeEnvironment(constraint);
                        // Remove environment and argument escaping
                        constraint = constraint.replace(/\\\$/g, '$');
                        return [4 /*yield*/, this.evaluateConstraint('Condition', constraint, options, outputPattern)];
                    case 3:
                        if (!(_k.sent())) {
                            condition = false;
                            return [3 /*break*/, 5];
                        }
                        _k.label = 4;
                    case 4:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_13_1 = _k.sent();
                        e_13 = { error: e_13_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (_b && !_b.done && (_g = _a.return)) _g.call(_a);
                        }
                        finally { if (e_13) throw e_13.error; }
                        return [7 /*endfinally*/];
                    case 8:
                        _k.trys.push([8, 13, 14, 15]);
                        _c = __values(task.exclusion), _d = _c.next();
                        _k.label = 9;
                    case 9:
                        if (!!_d.done) return [3 /*break*/, 12];
                        constraint = _d.value;
                        constraint = Executor.expandEnvironment(constraint, options.env);
                        if (!!Executor.extendEnvironment(options.env, constraint)) return [3 /*break*/, 11];
                        outputMatches = constraint.match(/(.*)\|\?(.*)/);
                        outputPattern = null;
                        if (outputMatches !== null) {
                            constraint = outputMatches[1].trim();
                            outputPattern = Executor.expandEnvironment(outputMatches[2].trim(), options.env);
                            outputPattern = Executor.removeEnvironment(outputPattern);
                        }
                        if (options.cwd instanceof url_1.URL) {
                            throw new Error('A directory type of type URL is not supported.');
                        }
                        constraint = Executor.expandGlobs(constraint, __assign(__assign({}, this.globOptions), { cwd: options.cwd }));
                        constraint = Executor.removeEnvironment(constraint);
                        return [4 /*yield*/, this.evaluateConstraint('Exclusion', constraint, options, outputPattern)];
                    case 10:
                        if (_k.sent()) {
                            exclusion = true;
                            return [3 /*break*/, 12];
                        }
                        _k.label = 11;
                    case 11:
                        _d = _c.next();
                        return [3 /*break*/, 9];
                    case 12: return [3 /*break*/, 15];
                    case 13:
                        e_14_1 = _k.sent();
                        e_14 = { error: e_14_1 };
                        return [3 /*break*/, 15];
                    case 14:
                        try {
                            if (_d && !_d.done && (_h = _c.return)) _h.call(_c);
                        }
                        finally { if (e_14) throw e_14.error; }
                        return [7 /*endfinally*/];
                    case 15:
                        _k.trys.push([15, 20, 21, 22]);
                        _e = __values(task.confirm), _f = _e.next();
                        _k.label = 16;
                    case 16:
                        if (!!_f.done) return [3 /*break*/, 19];
                        confirm = _f.value;
                        confirm = Executor.expandEnvironment(confirm, options.env);
                        if (options.cwd instanceof url_1.URL) {
                            throw new Error('A directory type of type URL is not supported.');
                        }
                        confirm = Executor.expandGlobs(confirm, __assign(__assign({}, this.globOptions), { cwd: options.cwd }));
                        confirm = Executor.removeEnvironment(confirm);
                        logger_1.Logger.log(common_1.Colors.Bold + 'Confirm         : ' + common_1.Colors.Normal + common_1.Colors.Green + "'" + confirm + "'" + common_1.Colors.Normal);
                        return [4 /*yield*/, (0, common_1.confirmPrompt)(confirm, this.confirm)];
                    case 17:
                        confirmation = _k.sent();
                        if (!confirmation)
                            return [3 /*break*/, 19];
                        _k.label = 18;
                    case 18:
                        _f = _e.next();
                        return [3 /*break*/, 16];
                    case 19: return [3 /*break*/, 22];
                    case 20:
                        e_15_1 = _k.sent();
                        e_15 = { error: e_15_1 };
                        return [3 /*break*/, 22];
                    case 21:
                        try {
                            if (_f && !_f.done && (_j = _e.return)) _j.call(_e);
                        }
                        finally { if (e_15) throw e_15.error; }
                        return [7 /*endfinally*/];
                    case 22: return [2 /*return*/, condition && confirmation && !exclusion];
                }
            });
        });
    };
    Executor.prototype.expandTasks = function (parents, tasks, environment, args, parameters, meta) {
        var e_16, _a, e_17, _b;
        var result = [];
        try {
            for (var tasks_3 = __values(tasks), tasks_3_1 = tasks_3.next(); !tasks_3_1.done; tasks_3_1 = tasks_3.next()) {
                var task = tasks_3_1.value;
                if (typeof task === 'string') {
                    task = Executor.expandArguments(task, args);
                    task = Executor.expandEnvironment(task, environment);
                    var scripts = this.scripts.find(task);
                    var scriptInfo = scripts_1.Scripts.select(scripts, parents, meta);
                    if (scriptInfo) {
                        if (scriptInfo.multiple) {
                            try {
                                for (var _c = (e_17 = void 0, __values(scriptInfo.script)), _d = _c.next(); !_d.done; _d = _c.next()) {
                                    var script = _d.value;
                                    script = Executor.expandArguments(script, args);
                                    script = Executor.expandEnvironment(script, environment);
                                    result.push(script);
                                }
                            }
                            catch (e_17_1) { e_17 = { error: e_17_1 }; }
                            finally {
                                try {
                                    if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                                }
                                finally { if (e_17) throw e_17.error; }
                            }
                            continue;
                        }
                        scriptInfo.arguments = __spreadArray([scriptInfo.name], __read(scriptInfo.arguments), false);
                        var tasks_4 = this.expand(scriptInfo, parents);
                        if (!Executor.isEmptyTask(tasks_4))
                            result.push(tasks_4);
                    }
                    else {
                        if (tasks.length === 1 && parents.length > 0 && task === parents[parents.length - 1])
                            task = Executor.expandArguments(task + ' $*', args);
                        result.push(task);
                    }
                }
                else {
                    var scriptInfo = {
                        name: 'inline-script-block',
                        inline: true,
                        multiple: false,
                        parameters: parameters,
                        arguments: args,
                        script: task
                    };
                    if (task.repeater) {
                        result.push.apply(result, __spreadArray([], __read(this.expand(scriptInfo, parents).sequential), false));
                    }
                    else {
                        result.push(this.expand(scriptInfo, parents));
                    }
                }
            }
        }
        catch (e_16_1) { e_16 = { error: e_16_1 }; }
        finally {
            try {
                if (tasks_3_1 && !tasks_3_1.done && (_a = tasks_3.return)) _a.call(tasks_3);
            }
            finally { if (e_16) throw e_16.error; }
        }
        return result;
    };
    Executor.assignmentPattern = "^(\\w+)=([\\$\\w\\,\\.\\-\\@\\#\\%\\^\\*\\:\\;\\+\\/\\\\~\\=\\[\\]\\{\\}\\\"\\']+|\".*\"|'.*')$";
    return Executor;
}());
exports.Executor = Executor;
