"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.launchMenu = void 0;
var config_loader_1 = require("./config-loader");
var executor_1 = require("./executor");
var common_1 = require("./common");
var elements_1 = require("prompts/lib/elements");
function launchMenu(environment, settings, config, args, interactive, timeout, menuConfirm, confirm, limit, testmode) {
    return __awaiter(this, void 0, void 0, function () {
        var defaultChoice, script, shell, defaultSelect, pageSize, autoIndex, items, length, index, _a, command, executor, _b;
        var _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _d.trys.push([0, 7, , 8]);
                    defaultChoice = config.options.menu.defaultChoice.split(':');
                    script = {
                        name: config.options.menu.defaultChoice,
                        inline: false,
                        multiple: false,
                        parameters: {},
                        arguments: [],
                        script: config.options.menu.defaultScript,
                        timedout: false
                    };
                    shell = config_loader_1.Config.evaluateShellOption(config.options.script.shell, true);
                    if (!(interactive || !script.script)) return [3 /*break*/, 4];
                    defaultSelect = args.length > 0 ? args[0] : config.options.menu.defaultSelect;
                    pageSize = config.options.menu.pageSize;
                    autoIndex = 0;
                    if (defaultSelect) {
                        items = defaultSelect.split(':');
                        length = items.length < defaultChoice.length ? items.length : defaultChoice.length;
                        for (index = 0; index < length; index++) {
                            defaultChoice[index] = items[index];
                        }
                        autoIndex = length;
                    }
                    return [4 /*yield*/, timeoutMenu(config.menu, pageSize, defaultChoice, timeout, autoIndex)];
                case 1:
                    script = _d.sent();
                    _a = !script.timedout && menuConfirm;
                    if (!_a) return [3 /*break*/, 3];
                    return [4 /*yield*/, (0, common_1.confirmPrompt)('Are you sure', undefined, true)];
                case 2:
                    _a = !(_d.sent());
                    _d.label = 3;
                case 3:
                    if (_a) {
                        return [2 /*return*/, {
                                startTime: process.hrtime(),
                                exitCode: 0
                            }];
                    }
                    console.log();
                    return [3 /*break*/, 5];
                case 4:
                    console.log(common_1.Colors.Bold +
                        'Auto menu: ' +
                        common_1.Colors.Dim +
                        script.name.padEnd(28) +
                        common_1.Colors.Normal +
                        common_1.Colors.Dim +
                        '  (Use the menu by running:' +
                        common_1.Colors.Bold +
                        ' npm start menu' +
                        common_1.Colors.Normal +
                        common_1.Colors.Dim +
                        ')' +
                        common_1.Colors.Normal);
                    _d.label = 5;
                case 5:
                    if (!script.name.startsWith('menu:'))
                        script.name = 'menu:' + script.name;
                    command = getStartCommand(script.script, config.scripts);
                    if (command && environment.npm_lifecycle_event === 'start') {
                        console.log(common_1.Colors.Bold + 'Executing: ' + common_1.Colors.Dim + 'npm start ' + script.script + common_1.Colors.Normal);
                        console.log();
                    }
                    executor = new executor_1.Executor(shell, environment, settings, config.scripts, config.options.glob, confirm, limit, testmode);
                    script.arguments = args;
                    _c = {
                        startTime: executor.startTime
                    };
                    return [4 /*yield*/, executor.execute(script)];
                case 6: return [2 /*return*/, (_c.exitCode = _d.sent(),
                        _c)];
                case 7:
                    _b = _d.sent();
                    return [2 /*return*/, {
                            startTime: [0, 0],
                            exitCode: 0
                        }];
                case 8: return [2 /*return*/];
            }
        });
    });
}
exports.launchMenu = launchMenu;
function getStartCommand(script, scripts) {
    var result = [];
    if (script.concurrent)
        return null;
    if (script.sequential)
        return null;
    if (script['concurrent-then'])
        return null;
    if (script['sequential-then'])
        return null;
    if (script['concurrent-else'])
        return null;
    if (script['sequential-else'])
        return null;
    if (script instanceof Array)
        result.push.apply(result, __spreadArray([], __read(script), false));
    if (typeof script === 'string')
        result.push(script);
    if (script instanceof String)
        result.push(script.toString());
    if (result.length !== 1 || scripts.find(result[0]).length === 0)
        return null;
    return result[0];
}
function getMenuItem(label) {
    var match = label.match(/(.*?)\:(.*)$/);
    if (match) {
        return {
            name: match[1],
            help: match[2]
        };
    }
    return {
        name: label,
        help: ''
    };
}
function findMenuItem(menu, name) {
    var e_1, _a;
    try {
        for (var _b = __values(Object.entries(menu)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), label = _d[0], value = _d[1];
            var item = getMenuItem(label);
            if (item.name === name)
                return value;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return null;
}
function createChoices(menu) {
    var e_2, _a, e_3, _b;
    var choices = [];
    var menuHelp = {};
    var menuItems = {};
    try {
        for (var _c = __values(Object.entries(menu)), _d = _c.next(); !_d.done; _d = _c.next()) {
            var _e = __read(_d.value, 2), name = _e[0], value = _e[1];
            if (name !== 'description') {
                var item = getMenuItem(name);
                menuHelp[item.name] = item.help;
                menuItems[item.name] = value;
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_2) throw e_2.error; }
    }
    try {
        for (var _f = __values(Object.entries(menuItems)), _g = _f.next(); !_g.done; _g = _f.next()) {
            var _h = __read(_g.value, 2), name = _h[0], value = _h[1];
            if (name === 'separator' && typeof value === 'string') {
                // Separator not supported by prompts
            }
            else {
                if (Object.keys(value).length !== 0) {
                    choices.push({
                        title: name,
                        value: name,
                        description: menuHelp[name]
                    });
                }
            }
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
        }
        finally { if (e_3) throw e_3.error; }
    }
    return choices;
}
function getDefaultScript(menu, choices) {
    var index = 0;
    var _loop_1 = function () {
        var filtered = Object.entries(menu).filter(function (_a) {
            var _b = __read(_a, 2), key = _b[0], value = _b[1];
            return key !== 'description' && key !== 'separator' && !!value && Object.entries(value).length > 0;
        });
        var choice = choices[index++];
        var result = filtered.find(function (_a) {
            var _b = __read(_a, 2), label = _b[0], value = _b[1];
            return getMenuItem(label).name === choice;
        });
        if (result === undefined)
            result = filtered[0];
        if (result === undefined)
            return { value: '' };
        var _a = __read(result, 2), key = _a[0], value = _a[1];
        if (typeof value === 'string')
            return { value: value };
        if (Array.isArray(value))
            return { value: value };
        menu = value;
    };
    do {
        var state_1 = _loop_1();
        if (typeof state_1 === "object")
            return state_1.value;
    } while (index < 30);
    return '';
}
function timeoutMenu(menu, pageSize, defaultChoice, timeout, autoIndex) {
    return __awaiter(this, void 0, void 0, function () {
        var menuPromise, timeoutId, currentTimeout, listener_1, scriptInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    timeoutId = null;
                    currentTimeout = timeout;
                    if (currentTimeout > 0) {
                        timeoutId = setInterval(function () {
                            if (--currentTimeout > 0) {
                                process.stdout.write('\x1b[s'); // Save cursor position
                                console.info();
                                process.stdout.write(common_1.Colors.Bold + 'Auto select in: ' + common_1.Colors.Normal + currentTimeout);
                                process.stdout.write('\x1b[u'); // Restore cursor position
                                return;
                            }
                            clearTimeout(timeoutId);
                            timeoutId = null;
                            menuPromise.close();
                        }, 1000);
                        listener_1 = function (char, key) {
                            clearTimeout(timeoutId);
                            if (currentTimeout !== timeout) {
                                process.stdout.write('\x1b[s'); // Save cursor position
                                console.info();
                                process.stdout.write('\x1b[K');
                                process.stdout.write('\x1b[u'); // Restore cursor position
                            }
                            process.stdin.removeListener('keypress', listener_1);
                        };
                        process.stdin.on('keypress', listener_1);
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, , 3, 4]);
                    menuPromise = promptMenu(menu, pageSize, defaultChoice, [], autoIndex);
                    return [4 /*yield*/, menuPromise];
                case 2:
                    scriptInfo = _a.sent();
                    if (scriptInfo === null) {
                        return [2 /*return*/, {
                                name: defaultChoice.join(':'),
                                inline: false,
                                multiple: false,
                                parameters: {},
                                arguments: [],
                                script: getDefaultScript(menu, defaultChoice),
                                timedout: true
                            }];
                    }
                    return [2 /*return*/, __assign(__assign({}, scriptInfo), {
                            timedout: false
                        })];
                case 3:
                    if (timeoutId)
                        clearTimeout(timeoutId);
                    return [7 /*endfinally*/];
                case 4: return [2 /*return*/];
            }
        });
    });
}
function promptMenu(menu, pageSize, defaults, choice, autoIndex) {
    var choices = createChoices(menu);
    var close = false;
    defaults = __spreadArray([], __read(defaults), false);
    if (choices.length === 0) {
        console.log('Nothing to do: Menu not available and no action specified.');
        throw new Error('Nothing to do: Menu not available and no action specified.');
    }
    var initialIndex = choices.findIndex(function (item) { return item.title === defaults[0]; });
    if (initialIndex === -1)
        initialIndex = 0;
    var selectMenu = new elements_1.SelectPrompt({
        type: 'select',
        name: 'value',
        message: 'Select' + (menu.description ? ' ' + menu.description : ''),
        initial: initialIndex,
        choices: choices
    });
    var menuPromise = (0, common_1.toPromise)(selectMenu);
    if (autoIndex > 0)
        selectMenu.submit();
    var resultPromise = menuPromise.then(function (answer) {
        if (close || answer.length === 0)
            return null;
        var menuItem = findMenuItem(menu, answer[0]);
        if (menuItem === null) {
            var message = 'Menu item not found!';
            console.log(common_1.Colors.Bold + common_1.Colors.Red + message + common_1.Colors.Normal);
            throw new Error(message);
        }
        choice.push(answer[0]);
        defaults.shift();
        if (!isMenuObject(menuItem)) {
            return {
                name: choice.join(':'),
                inline: false,
                circular: false,
                multiple: false,
                parameters: {},
                arguments: [],
                script: menuItem
            };
        }
        return promptMenu(menuItem, pageSize, defaults, choice, autoIndex - 1);
    });
    resultPromise.close = function () {
        close = true;
        selectMenu.submit();
    };
    return resultPromise;
}
function isMenuObject(object) {
    if (object instanceof Array)
        return false;
    if (typeof object === 'string')
        return false;
    if (object.concurrent && object.concurrent instanceof Array)
        return false;
    if (object.sequential && object.sequential instanceof Array)
        return false;
    if (object['concurrent-then'] && object['concurrent-then'] instanceof Array)
        return false;
    if (object['sequential-then'] && object['sequential-then'] instanceof Array)
        return false;
    if (object['concurrent-else'] && object['concurrent-else'] instanceof Array)
        return false;
    if (object['sequential-else'] && object['sequential-else'] instanceof Array)
        return false;
    return true;
}
