"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.main = void 0;
var config_loader_1 = require("./config-loader");
var logger_1 = require("./logger");
var executor_1 = require("./executor");
var launch_menu_1 = require("./launch-menu");
var fs = require("fs");
var path = require("path");
var common_1 = require("./common");
var scripts_1 = require("./scripts");
var package_json_1 = require("./package.json");
var prettyTime = require("pretty-time");
var os = require("os");
var child_process_1 = require("child_process");
var npmScripts = [
    'prepublish',
    'prepare',
    'prepublishOnly',
    'prepack',
    'postpack',
    'publish',
    'postpublish',
    'preinstall',
    'install',
    'postinstall',
    'preuninstall',
    'uninstall',
    'postuninstall',
    'preversion',
    'version',
    'postversion',
    'pretest',
    'test',
    'posttest',
    'prestop',
    'stop',
    'poststop',
    'prestart',
    'start',
    'poststart',
    'prerestart',
    'restart',
    'postrestart',
    'preshrinkwrap',
    'shrinkwrap',
    'postshrinkwrap'
];
function showLoadedFiles(files) {
    var e_1, _a;
    try {
        for (var files_1 = __values(files), files_1_1 = files_1.next(); !files_1_1.done; files_1_1 = files_1.next()) {
            var file = files_1_1.value;
            logger_1.Logger.info('Loaded config: ', file);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (files_1_1 && !files_1_1.done && (_a = files_1.return)) _a.call(files_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    logger_1.Logger.info();
}
function showTemplates() {
    var e_2, _a;
    var templatePath = path.join(__dirname, 'templates');
    console.log(common_1.Colors.Bold + 'Available templates:' + common_1.Colors.Normal);
    console.log();
    try {
        for (var _b = __values(fs.readdirSync(templatePath)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var fileName = _c.value;
            console.log(fileName);
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_2) throw e_2.error; }
    }
    console.log();
    console.log(common_1.Colors.Bold + 'Example usage:' + common_1.Colors.Normal + ' npx launch init basic');
}
function copyTemplateFiles(template, directory) {
    var e_3, _a;
    var templatePath = path.join(__dirname, 'templates', template);
    console.log(common_1.Colors.Bold + 'Create starter config:' + common_1.Colors.Normal, template);
    console.log();
    if (!fs.existsSync(templatePath) || !fs.statSync(templatePath).isDirectory()) {
        throw new Error('Template not found.');
    }
    try {
        for (var _b = __values(fs.readdirSync(templatePath)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var fileName = _c.value;
            var sourceFile = path.join(templatePath, fileName);
            var targetFile = path.join(directory, fileName);
            if (!fs.existsSync(targetFile)) {
                console.log(common_1.Colors.Bold + 'Createing:' + common_1.Colors.Normal, targetFile.replace(process.cwd() + path.sep, ''));
                fs.copyFileSync(sourceFile, targetFile);
            }
            else {
                console.log(common_1.Colors.Yellow + common_1.Colors.Bold + 'Skipped:' + common_1.Colors.Normal, fileName + ' already exists.');
            }
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_3) throw e_3.error; }
    }
}
function splitCommand(command) {
    var result = [];
    var last = 0;
    var index = 0;
    while (index < command.length) {
        var value = command.substr(index);
        var semicolon = value.startsWith(';');
        if (value.startsWith('&&') || semicolon) {
            result.push(command.substr(last, index - last).trim() + (semicolon ? ' || true' : ''));
            index++;
            last = index + 1;
        }
        if (value.startsWith('(')) {
            var open = 1;
            while (open > 0 && ++index < command.length) {
                if (command[index] === '(')
                    open++;
                if (command[index] === ')')
                    open--;
            }
        }
        if (value.startsWith('"')) {
            while (++index < command.length && command[index] !== '"')
                ;
        }
        if (value.startsWith("'")) {
            while (++index < command.length && command[index] !== "'")
                ;
        }
        index++;
    }
    result.push(command.substr(last, index - last).trim());
    return result;
}
function checkCleanGit() {
    try {
        var result = (0, child_process_1.execSync)('git status --porcelain', { encoding: 'utf8', stdio: 'pipe' });
        return result.trim().length === 0;
    }
    catch (_a) { }
    return true;
}
function checkMigratePrerequisites(directory, scripts, testmode) {
    var menuFile = path.join(directory, 'launcher-menu.json');
    var configFile = path.join(directory, 'launcher-config.json');
    if (!testmode && !checkCleanGit()) {
        console.log(common_1.Colors.Red + common_1.Colors.Bold + 'Failed:' + common_1.Colors.Normal, 'Repository is not clean. Please commit or stash any changes before updating.');
        return false;
    }
    if (fs.existsSync(menuFile)) {
        console.log(common_1.Colors.Red + common_1.Colors.Bold + 'Failed:' + common_1.Colors.Normal, 'launcher-menu.json already exists.');
        return false;
    }
    if (fs.existsSync(configFile)) {
        console.log(common_1.Colors.Red + common_1.Colors.Bold + 'Failed:' + common_1.Colors.Normal, 'launcher-config.json already exists.');
        return false;
    }
    if (scripts && scripts.start !== undefined && scripts.start !== 'launch') {
        console.log(common_1.Colors.Red + common_1.Colors.Bold + 'Failed:' + common_1.Colors.Normal + ' Remove start script from package.json before running migrate.');
        return false;
    }
    return true;
}
function migrateMenu(scripts) {
    var e_4, _a, e_5, _b;
    var menuEntries = {
        description: ''
    };
    try {
        for (var _c = __values(Object.entries(scripts)), _d = _c.next(); !_d.done; _d = _c.next()) {
            var _e = __read(_d.value, 1), key = _e[0];
            var entries = key.split(':');
            var currMenu = menuEntries;
            var nextMenu = menuEntries;
            var entry = key;
            try {
                for (var entries_1 = (e_5 = void 0, __values(entries)), entries_1_1 = entries_1.next(); !entries_1_1.done; entries_1_1 = entries_1.next()) {
                    var item = entries_1_1.value;
                    entry = item;
                    currMenu = nextMenu;
                    if (currMenu === menuEntries)
                        entry += ':...';
                    while (typeof currMenu[entry] === 'string')
                        entry += ':menu';
                    if (nextMenu[entry] === undefined) {
                        nextMenu[entry] = {
                            description: ''
                        };
                    }
                    nextMenu = nextMenu[entry];
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (entries_1_1 && !entries_1_1.done && (_b = entries_1.return)) _b.call(entries_1);
                }
                finally { if (e_5) throw e_5.error; }
            }
            if (Object.entries(currMenu[entry]).length > 1)
                entry += ':command';
            currMenu[entry] = key;
        }
    }
    catch (e_4_1) { e_4 = { error: e_4_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_4) throw e_4.error; }
    }
    return menuEntries;
}
function migrateScripts(scripts) {
    var e_6, _a;
    var sourceScripts = {};
    var targetScripts = {};
    try {
        for (var _b = __values(Object.entries(scripts).sort(function (_a, _b) {
            var _c = __read(_a, 1), key1 = _c[0];
            var _d = __read(_b, 1), key2 = _d[0];
            return key1.localeCompare(key2);
        })), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), key = _d[0], value = _d[1];
            var values = splitCommand(value);
            if (values.length > 1) {
                values = values.map(function (item) {
                    if (item.startsWith('npm run ')) {
                        item = item.trim().replace('npm run ', '');
                        item = item.trim().replace(' || true', '');
                        item = item.trim();
                    }
                    return item;
                });
                values = values.map(function (item) {
                    if (item.startsWith('cd ')) {
                        item = item.trim().replace('cd ', '');
                        item = item.trim().replace(' || true', '');
                        item = item.trim();
                    }
                    return item;
                });
                targetScripts[key] = values;
            }
            else {
                targetScripts[key] = value;
            }
            if (npmScripts.includes(key))
                sourceScripts[key] = 'launch';
        }
    }
    catch (e_6_1) { e_6 = { error: e_6_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_6) throw e_6.error; }
    }
    return {
        source: sourceScripts,
        target: targetScripts
    };
}
function objectFromEntries(entries) {
    var e_7, _a;
    var object = {};
    try {
        for (var entries_2 = __values(entries), entries_2_1 = entries_2.next(); !entries_2_1.done; entries_2_1 = entries_2.next()) {
            var _b = __read(entries_2_1.value, 2), name = _b[0], value = _b[1];
            object[name] = value;
        }
    }
    catch (e_7_1) { e_7 = { error: e_7_1 }; }
    finally {
        try {
            if (entries_2_1 && !entries_2_1.done && (_a = entries_2.return)) _a.call(entries_2);
        }
        finally { if (e_7) throw e_7.error; }
    }
    return object;
}
function parameterize(key, value, preserveParams) {
    var e_8, _a;
    var params = key.split(':');
    var index = 0;
    try {
        for (var params_1 = __values(params), params_1_1 = params_1.next(); !params_1_1.done; params_1_1 = params_1.next()) {
            var param = params_1_1.value;
            if (index >= preserveParams) {
                var expression = new RegExp(param, 'g');
                if (value.includes(param)) {
                    key = key.replace(expression, '$param' + index);
                    value = value.replace(expression, '$param' + index);
                }
            }
            index++;
        }
    }
    catch (e_8_1) { e_8 = { error: e_8_1 }; }
    finally {
        try {
            if (params_1_1 && !params_1_1.done && (_a = params_1.return)) _a.call(params_1);
        }
        finally { if (e_8) throw e_8.error; }
    }
    return { key: key, value: value, params: params };
}
function getScriptDefinitions(scripts, preserveParams) {
    var e_9, _a;
    var definitions = {};
    try {
        for (var _b = __values(Object.entries(scripts)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), key = _d[0], value = _d[1];
            var parameters = parameterize(key, value, preserveParams);
            var definition = definitions[parameters.value];
            if (definition === undefined) {
                definition = {
                    keys: [],
                    params: []
                };
                definitions[parameters.value] = definition;
            }
            if (!definition.keys.includes(parameters.key))
                definition.keys.push(parameters.key);
            definition.params.push(parameters.params);
        }
    }
    catch (e_9_1) { e_9 = { error: e_9_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_9) throw e_9.error; }
    }
    var sorted = Object.entries(definitions).sort(function (_a, _b) {
        var _c = __read(_a, 2), definition1 = _c[1];
        var _d = __read(_b, 2), definition2 = _d[1];
        return definition2.params.length - definition1.params.length;
    });
    return objectFromEntries(sorted);
}
function expandParams(name, command, params) {
    var e_10, _a;
    var match = null;
    var length = (params.find(function () { return true; }) || { length: 0 }).length;
    var keys = name.split(':');
    var _loop_1 = function (index) {
        if (keys[index].startsWith('$')) {
            var value = __spreadArray([], __read(new Set(params.map(function (item) { return item[index]; }))), false);
            if (match === null || value.length <= match.value.length) {
                match = {
                    index: index,
                    value: value
                };
            }
        }
    };
    for (var index = 0; index < length; index++) {
        _loop_1(index);
    }
    if (match === null)
        return [];
    var expression = new RegExp('\\$param' + match.index, 'g');
    var result = [];
    try {
        for (var _b = __values(match.value), _c = _b.next(); !_c.done; _c = _b.next()) {
            var item = _c.value;
            result.push({
                name: name.replace(expression, item),
                command: command.replace(expression, item)
            });
        }
    }
    catch (e_10_1) { e_10 = { error: e_10_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_10) throw e_10.error; }
    }
    return result;
}
function resolveConflicts(scripts, name, command, params) {
    var e_11, _a;
    if (scripts[name] === undefined)
        return [{ name: name, command: command }];
    var expanded = expandParams(name, command, params);
    var result = [];
    try {
        for (var expanded_1 = __values(expanded), expanded_1_1 = expanded_1.next(); !expanded_1_1.done; expanded_1_1 = expanded_1.next()) {
            var item = expanded_1_1.value;
            result.push.apply(result, __spreadArray([], __read(resolveConflicts(scripts, item.name, item.command, params)), false));
        }
    }
    catch (e_11_1) { e_11 = { error: e_11_1 }; }
    finally {
        try {
            if (expanded_1_1 && !expanded_1_1.done && (_a = expanded_1.return)) _a.call(expanded_1);
        }
        finally { if (e_11) throw e_11.error; }
    }
    return result;
}
function combineScripts(scripts, preserveParams) {
    var e_12, _a, e_13, _b, e_14, _c;
    var definitions = getScriptDefinitions(scripts, preserveParams);
    var combineScripts = {};
    try {
        for (var _d = __values(Object.entries(definitions)), _e = _d.next(); !_e.done; _e = _d.next()) {
            var _f = __read(_e.value, 2), script = _f[0], definition = _f[1];
            try {
                for (var _g = (e_13 = void 0, __values(definition.keys)), _h = _g.next(); !_h.done; _h = _g.next()) {
                    var key = _h.value;
                    var scripts_3 = [];
                    scripts_3.push.apply(scripts_3, __spreadArray([], __read(resolveConflicts(combineScripts, key, script, definition.params)), false));
                    try {
                        for (var scripts_2 = (e_14 = void 0, __values(scripts_3)), scripts_2_1 = scripts_2.next(); !scripts_2_1.done; scripts_2_1 = scripts_2.next()) {
                            var script_1 = scripts_2_1.value;
                            combineScripts[script_1.name] = script_1.command;
                        }
                    }
                    catch (e_14_1) { e_14 = { error: e_14_1 }; }
                    finally {
                        try {
                            if (scripts_2_1 && !scripts_2_1.done && (_c = scripts_2.return)) _c.call(scripts_2);
                        }
                        finally { if (e_14) throw e_14.error; }
                    }
                }
            }
            catch (e_13_1) { e_13 = { error: e_13_1 }; }
            finally {
                try {
                    if (_h && !_h.done && (_b = _g.return)) _b.call(_g);
                }
                finally { if (e_13) throw e_13.error; }
            }
        }
    }
    catch (e_12_1) { e_12 = { error: e_12_1 }; }
    finally {
        try {
            if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
        }
        finally { if (e_12) throw e_12.error; }
    }
    return combineScripts;
}
function migratePackageJson(directory, preserveParams, confirm, testmode) {
    return __awaiter(this, void 0, void 0, function () {
        var menuFile, configFile, packageFile, content, menuEntries, combinedScripts, scripts, targetCount, sourceCount, autoValue;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    menuFile = path.join(directory, 'launcher-menu.json');
                    configFile = path.join(directory, 'launcher-config.json');
                    packageFile = path.join(directory, 'package.json');
                    console.log(common_1.Colors.Bold + 'Migrating: ' + common_1.Colors.Normal + 'package.json');
                    console.log();
                    content = JSON.parse(fs.readFileSync(packageFile).toString());
                    if (!checkMigratePrerequisites(directory, content.scripts, testmode))
                        return [2 /*return*/];
                    menuEntries = migrateMenu(content.scripts);
                    combinedScripts = combineScripts(content.scripts, preserveParams);
                    scripts = migrateScripts(combinedScripts);
                    targetCount = Object.entries(scripts.target).length;
                    sourceCount = Object.entries(scripts.source).length;
                    console.log('Script to migrate:', targetCount - sourceCount);
                    console.log('Script to update:', sourceCount + 1);
                    console.log();
                    scripts.source.start = 'launch';
                    content.scripts = scripts.source;
                    logger_1.Logger.log('package.json:', content);
                    logger_1.Logger.log();
                    logger_1.Logger.log('launcher-menu.json:', {
                        menu: menuEntries
                    });
                    logger_1.Logger.log();
                    logger_1.Logger.log('launcher-config.json:', {
                        scripts: scripts.target
                    });
                    logger_1.Logger.log();
                    if (confirm !== undefined)
                        autoValue = confirm;
                    if (testmode)
                        autoValue = true;
                    return [4 /*yield*/, (0, common_1.confirmPrompt)('Are you sure', autoValue)];
                case 1:
                    if (_a.sent()) {
                        console.log();
                        console.log(common_1.Colors.Bold + 'Updating:' + common_1.Colors.Normal, packageFile.replace(process.cwd() + path.sep, ''));
                        fs.writeFileSync(packageFile, JSON.stringify(content, null, 2) + '\n');
                        console.log(common_1.Colors.Bold + 'Creating:' + common_1.Colors.Normal, menuFile.replace(process.cwd() + path.sep, ''));
                        fs.writeFileSync(menuFile, JSON.stringify({
                            menu: menuEntries
                        }, null, 2) + '\n');
                        console.log(common_1.Colors.Bold + 'Creating:' + common_1.Colors.Normal, configFile.replace(process.cwd() + path.sep, ''));
                        fs.writeFileSync(configFile, JSON.stringify({
                            scripts: scripts.target
                        }, null, 2) + '\n');
                    }
                    return [2 /*return*/];
            }
        });
    });
}
function updatePackageJson(directory) {
    var fileName = path.join(directory, 'package.json');
    console.log(common_1.Colors.Bold + 'Updating package.json.' + common_1.Colors.Normal);
    console.log();
    if (!fs.existsSync(fileName)) {
        console.log(common_1.Colors.Bold + 'Update package.json failed:' + common_1.Colors.Normal + ' file not found.');
        return;
    }
    try {
        var buffer = fs.readFileSync(fileName);
        var content = JSON.parse(buffer.toString());
        if (content.scripts && content.scripts.start !== undefined) {
            if (content.scripts.start === 'launch') {
                console.log(common_1.Colors.Yellow + common_1.Colors.Bold + 'Skipped:' + common_1.Colors.Normal + ' start script is up-to-date.');
            }
            else {
                console.log(common_1.Colors.Yellow + common_1.Colors.Bold + 'Skipped:' + common_1.Colors.Normal + ' start script already in use.');
            }
            return;
        }
        if (!content.scripts)
            content.scripts = {};
        content.scripts.start = 'launch';
        fs.writeFileSync(fileName, JSON.stringify(content, null, 2) + '\n');
        console.log(common_1.Colors.Bold + 'Start script of package.json updated.' + common_1.Colors.Normal);
    }
    catch (error) {
        console.log(common_1.Colors.Bold + 'Update package.json failed: ' + common_1.Colors.Normal + error.message);
    }
}
function showHelp() {
    (0, common_1.showArgsHelp)('launch', {
        init: ['', 'Commands:', '  ' + common_1.Colors.Cyan + 'init         ' + common_1.Colors.Normal + '[template] Create starter config files.'],
        list: '  ' + common_1.Colors.Cyan + 'list         ' + common_1.Colors.Normal + '[type] List available launcher scripts.',
        migrate: '  ' + common_1.Colors.Cyan + 'migrate      ' + common_1.Colors.Normal + 'Migrate your package.json scripts.',
        help: '  ' + common_1.Colors.Cyan + 'help         ' + common_1.Colors.Normal + 'Show this help.',
        version: '  ' + common_1.Colors.Cyan + 'version      ' + common_1.Colors.Normal + 'Outputs launcher version.',
        logLevel: ['', 'Options:', '  ' + common_1.Colors.Cyan + 'logLevel=    ' + common_1.Colors.Normal + 'Set log level.'],
        config: '  ' + common_1.Colors.Cyan + 'config=      ' + common_1.Colors.Normal + 'Merge in an extra config file.',
        confirm: '  ' + common_1.Colors.Cyan + 'confirm=     ' + common_1.Colors.Normal + 'Auto value for confirm conditions.',
        ansi: '  ' + common_1.Colors.Cyan + 'ansi=        ' + common_1.Colors.Normal + 'Enable or disable ansi color output.',
        directory: '  ' + common_1.Colors.Cyan + 'directory=   ' + common_1.Colors.Normal + 'The directory from which configuration files are loaded.',
        menuTimeout: '  ' + common_1.Colors.Cyan + 'menuTimeout= ' + common_1.Colors.Normal + 'Set menu timeout in seconds.',
        params: '  ' + common_1.Colors.Cyan + 'params=      ' + common_1.Colors.Normal + 'Set the number of parameters to preserve.',
        concurrent: '  ' + common_1.Colors.Cyan + 'concurrent=  ' + common_1.Colors.Normal + 'Execute commandline wildcard matches in parallel.',
        limit: '  ' + common_1.Colors.Cyan + 'limit=       ' + common_1.Colors.Normal + 'Limit the number of commands to execute in parallel.'
    });
}
function disableAnsiColors() {
    var e_15, _a;
    try {
        for (var _b = __values(Object.keys(common_1.Colors)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var key = _c.value;
            common_1.Colors[key] = '';
        }
    }
    catch (e_15_1) { e_15 = { error: e_15_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_15) throw e_15.error; }
    }
}
function getEnviromentValues() {
    var e_16, _a;
    var environment = __assign({}, process.env);
    try {
        for (var _b = __values(Object.entries(common_1.Colors)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), key = _d[0], value = _d[1];
            environment['launch_style_' + key.toLowerCase()] = value;
        }
    }
    catch (e_16_1) { e_16 = { error: e_16_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_16) throw e_16.error; }
    }
    environment.launch_time_start = (0, common_1.formatTime)();
    environment.launch_platform = process.platform;
    environment.launch_version = package_json_1.version;
    delete environment.launch_time_current;
    delete environment.launch_time_elapsed;
    return environment;
}
function getLaunchSetting(settings, prefix) {
    var e_17, _a, e_18, _b, _c;
    if (prefix === void 0) { prefix = 'launch_setting_'; }
    var result = {
        values: {},
        arrays: {}
    };
    try {
        for (var _d = __values(Object.entries(settings)), _e = _d.next(); !_e.done; _e = _d.next()) {
            var _f = __read(_e.value, 2), key = _f[0], value = _f[1];
            if (value instanceof Array) {
                var name = prefix + key;
                result.arrays[name] = [];
                try {
                    for (var value_1 = (e_18 = void 0, __values(value)), value_1_1 = value_1.next(); !value_1_1.done; value_1_1 = value_1.next()) {
                        var item = value_1_1.value;
                        if (typeof item !== 'object') {
                            result.arrays[name].push((_c = {},
                                _c['_'] = item,
                                _c));
                            continue;
                        }
                        var settings_1 = getLaunchSetting(item, '_');
                        result.arrays[name].push(settings_1.values);
                    }
                }
                catch (e_18_1) { e_18 = { error: e_18_1 }; }
                finally {
                    try {
                        if (value_1_1 && !value_1_1.done && (_b = value_1.return)) _b.call(value_1);
                    }
                    finally { if (e_18) throw e_18.error; }
                }
                continue;
            }
            if (typeof value === 'object') {
                var settings_2 = getLaunchSetting(value, prefix + key + '_');
                result.values = __assign(__assign({}, result.values), settings_2.values);
                result.arrays = __assign(__assign({}, result.arrays), settings_2.arrays);
                continue;
            }
            result.values[prefix + key.toLowerCase()] = value;
        }
    }
    catch (e_17_1) { e_17 = { error: e_17_1 }; }
    finally {
        try {
            if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
        }
        finally { if (e_17) throw e_17.error; }
    }
    return result;
}
function getRemaining(args) {
    var index = args.indexOf('--');
    if (index === -1)
        return [];
    return args.slice(index + 1);
}
function getMenuScripts(menu, result) {
    var e_19, _a;
    if (result === void 0) { result = []; }
    try {
        for (var _b = __values(Object.entries(menu)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), key = _d[0], value = _d[1];
            if (key === 'description')
                continue;
            if (key === 'separator')
                continue;
            if (typeof value === 'string') {
                if (value.includes(' '))
                    continue;
                result.push(value);
            }
            else {
                getMenuScripts(value, result);
            }
        }
    }
    catch (e_19_1) { e_19 = { error: e_19_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_19) throw e_19.error; }
    }
    return result;
}
function main(lifecycleEvent, processArgv, npmConfigArgv, testmode) {
    if (testmode === void 0) { testmode = false; }
    return __awaiter(this, void 0, void 0, function () {
        var exitCode, startTime, commandArgs, argsString, launchArgs, configLoad, config, interactive, fileName, shell, settings, environment, launchScript, scriptId, template, choices, unique, unique_1, unique_1_1, item, choices, unique, unique_2, unique_2_1, item, scripts_4, menu, choices, unique, unique_3, unique_3_1, item, scripts, defaultScript, result, scriptInfo, executor, error_1, message, timespan;
        var e_20, _a, e_21, _b, e_22, _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    exitCode = 1;
                    startTime = process.hrtime();
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 7, 8, 9]);
                    commandArgs = npmConfigArgv ? JSON.parse(npmConfigArgv).remain : [];
                    argsString = processArgv.slice(2, processArgv.length - commandArgs.length);
                    launchArgs = (0, common_1.parseArgs)(argsString, {
                        arguments: {
                            logLevel: undefined,
                            init: false,
                            list: false,
                            migrate: false,
                            confirm: undefined,
                            help: false,
                            version: false,
                            config: null,
                            script: null,
                            ansi: true,
                            directory: process.cwd(),
                            menuTimeout: undefined,
                            params: undefined,
                            concurrent: false,
                            limit: undefined
                        },
                        optionals: [],
                        unknowns: []
                    });
                    launchArgs.arguments.directory = path.join(launchArgs.arguments.directory); // remove starting ./
                    configLoad = config_loader_1.Config.load(launchArgs.arguments.directory);
                    config = configLoad.config;
                    interactive = false;
                    if (launchArgs.arguments.logLevel === undefined)
                        launchArgs.arguments.logLevel = config.options.logLevel;
                    if (launchArgs.arguments.menuTimeout === undefined)
                        launchArgs.arguments.menuTimeout = config.options.menu.timeout;
                    if (argsString.includes('--params') && launchArgs.arguments.params === undefined)
                        launchArgs.arguments.params = 1;
                    if (launchArgs.arguments.params === undefined)
                        launchArgs.arguments.params = Number.MAX_SAFE_INTEGER;
                    if (launchArgs.arguments.limit === undefined)
                        launchArgs.arguments.limit = config.options.limit;
                    if (launchArgs.arguments.limit === 0)
                        launchArgs.arguments.limit = os.cpus().length;
                    if (launchArgs.arguments.limit < 1)
                        launchArgs.arguments.limit = 1;
                    logger_1.Logger.level = launchArgs.arguments.logLevel;
                    if (launchArgs.arguments.config) {
                        fileName = path.join(launchArgs.arguments.directory, launchArgs.arguments.config);
                        config = config.merge(fileName);
                        configLoad.files.push(fileName);
                    }
                    shell = config_loader_1.Config.evaluateShellOption(config.options.script.shell, true);
                    if (!launchArgs.arguments.ansi)
                        disableAnsiColors();
                    if (process.platform === 'win32')
                        common_1.Colors.Dim = '\x1b[90m';
                    settings = getLaunchSetting(config.settings);
                    environment = __assign(__assign({}, getEnviromentValues()), settings.values);
                    if (testmode)
                        environment.launch_time_start = (0, common_1.formatTime)(new Date('2019-09-16T12:33:20.628').getTime(), 0);
                    showLoadedFiles(configLoad.files);
                    launchScript = lifecycleEvent ? [lifecycleEvent] : [];
                    scriptId = '';
                    if (launchArgs.unknowns.length === 0) {
                        if (lifecycleEvent === 'start') {
                            launchScript = commandArgs[0] ? [commandArgs[0]] : [];
                            scriptId = commandArgs.shift();
                        }
                    }
                    else {
                        launchScript = launchArgs.unknowns;
                    }
                    logger_1.Logger.debug('Config: ', (0, common_1.stringify)(config));
                    logger_1.Logger.info(common_1.Colors.Bold + 'Date              :', environment.launch_time_start + common_1.Colors.Normal);
                    logger_1.Logger.info('Version           :', package_json_1.version);
                    logger_1.Logger.info('Lifecycle event   :', lifecycleEvent);
                    logger_1.Logger.info('Launch script     :', launchScript);
                    logger_1.Logger.debug('Process platform  :', process.platform);
                    logger_1.Logger.debug('Script shell      :', shell);
                    if (logger_1.Logger.level > 2) {
                        logger_1.Logger.info('Launch arguments  :', launchArgs);
                    }
                    else {
                        logger_1.Logger.info('Launch arguments  :', argsString);
                    }
                    if (Object.entries(config.scripts.scripts).length === 0) {
                        logger_1.Logger.info();
                        logger_1.Logger.info('Warning: No launcher scripts loaded.');
                        logger_1.Logger.info();
                    }
                    if (launchArgs.arguments.version) {
                        console.log(package_json_1.version);
                        logger_1.Logger.log();
                        exitCode = 0;
                        return [2 /*return*/];
                    }
                    if (launchArgs.arguments.help) {
                        showHelp();
                        logger_1.Logger.log();
                        exitCode = 0;
                        return [2 /*return*/];
                    }
                    if (launchArgs.arguments.init) {
                        template = launchArgs.optionals[0];
                        if (!template) {
                            showTemplates();
                            return [2 /*return*/];
                        }
                        copyTemplateFiles(template, launchArgs.arguments.directory);
                        console.log();
                        updatePackageJson(launchArgs.arguments.directory);
                        logger_1.Logger.log();
                        exitCode = 0;
                        return [2 /*return*/];
                    }
                    if (launchArgs.arguments.list) {
                        if (launchArgs.optionals[0] === 'script') {
                            choices = Object.keys(configLoad.config.scripts.scripts).sort();
                            unique = __spreadArray([], __read(new Set(choices)), false);
                            try {
                                for (unique_1 = __values(unique), unique_1_1 = unique_1.next(); !unique_1_1.done; unique_1_1 = unique_1.next()) {
                                    item = unique_1_1.value;
                                    console.log(item);
                                }
                            }
                            catch (e_20_1) { e_20 = { error: e_20_1 }; }
                            finally {
                                try {
                                    if (unique_1_1 && !unique_1_1.done && (_a = unique_1.return)) _a.call(unique_1);
                                }
                                finally { if (e_20) throw e_20.error; }
                            }
                            return [2 /*return*/];
                        }
                        if (launchArgs.optionals[0] === 'menu') {
                            choices = getMenuScripts(configLoad.config.menu).sort();
                            unique = __spreadArray([], __read(new Set(choices)), false);
                            try {
                                for (unique_2 = __values(unique), unique_2_1 = unique_2.next(); !unique_2_1.done; unique_2_1 = unique_2.next()) {
                                    item = unique_2_1.value;
                                    console.log(item);
                                }
                            }
                            catch (e_21_1) { e_21 = { error: e_21_1 }; }
                            finally {
                                try {
                                    if (unique_2_1 && !unique_2_1.done && (_b = unique_2.return)) _b.call(unique_2);
                                }
                                finally { if (e_21) throw e_21.error; }
                            }
                            return [2 /*return*/];
                        }
                        if (launchArgs.optionals.length === 0 || launchArgs.optionals[0] === 'complete') {
                            scripts_4 = Object.keys(configLoad.config.scripts.scripts).filter(function (item) { return !item.includes('$'); });
                            menu = getMenuScripts(configLoad.config.menu).filter(function (item) { return !scripts_4.includes(item); });
                            choices = __spreadArray(__spreadArray([], __read(menu), false), __read(scripts_4), false).sort();
                            unique = __spreadArray([], __read(new Set(choices)), false);
                            try {
                                for (unique_3 = __values(unique), unique_3_1 = unique_3.next(); !unique_3_1.done; unique_3_1 = unique_3.next()) {
                                    item = unique_3_1.value;
                                    console.log(item);
                                }
                            }
                            catch (e_22_1) { e_22 = { error: e_22_1 }; }
                            finally {
                                try {
                                    if (unique_3_1 && !unique_3_1.done && (_c = unique_3.return)) _c.call(unique_3);
                                }
                                finally { if (e_22) throw e_22.error; }
                            }
                            return [2 /*return*/];
                        }
                        console.error('List option not supported: ' + launchArgs.optionals);
                        console.error();
                        console.error('Use: script, menu or complete');
                        throw new Error();
                    }
                    if (!launchArgs.arguments.migrate) return [3 /*break*/, 3];
                    return [4 /*yield*/, migratePackageJson(launchArgs.arguments.directory, launchArgs.arguments.params, launchArgs.arguments.confirm, testmode)];
                case 2:
                    _e.sent();
                    logger_1.Logger.log();
                    exitCode = 0;
                    return [2 /*return*/];
                case 3:
                    commandArgs.unshift.apply(commandArgs, __spreadArray([], __read(getRemaining(argsString)), false));
                    if (scriptId)
                        commandArgs.unshift(scriptId);
                    scripts = (_d = config.scripts).find.apply(_d, __spreadArray([], __read(launchScript), false));
                    defaultScript = config.scripts.find('start');
                    if (scripts.length === 0) {
                        if (launchScript[0] === 'menu') {
                            interactive = true;
                            launchScript = [];
                            commandArgs.shift();
                            defaultScript.length = 0;
                        }
                        if (defaultScript.length > 0) {
                            scripts.push.apply(scripts, __spreadArray([], __read(defaultScript), false));
                            launchScript = ['start'];
                        }
                    }
                    if (!(launchScript.length === 0)) return [3 /*break*/, 5];
                    logger_1.Logger.info();
                    return [4 /*yield*/, (0, launch_menu_1.launchMenu)(environment, settings, config, commandArgs, interactive, launchArgs.arguments.menuTimeout, config.options.menu.confirm, launchArgs.arguments.confirm, launchArgs.arguments.limit, testmode)];
                case 4:
                    result = _e.sent();
                    startTime = result.startTime;
                    exitCode = result.exitCode;
                    return [2 /*return*/];
                case 5:
                    scriptInfo = scripts_1.Scripts.select(scripts);
                    if (!scriptInfo)
                        throw new Error('Cannot start launch script ' + JSON.stringify(launchScript, null, 0) + ': No such script available.');
                    if (scriptInfo.multiple && launchArgs.arguments.concurrent) {
                        scriptInfo.script = {
                            concurrent: scriptInfo.script
                        };
                    }
                    if (launchArgs.unknowns.length === 0 && lifecycleEvent === 'start') {
                        commandArgs[0] = scripts_1.Scripts.parse(launchScript[0]).command;
                    }
                    else {
                        commandArgs.unshift(scripts_1.Scripts.parse(launchScript[0]).command);
                    }
                    if (!scriptInfo.name)
                        scriptInfo.name = launchScript[0];
                    scriptInfo.arguments = commandArgs;
                    logger_1.Logger.info();
                    executor = new executor_1.Executor(shell, environment, settings, config.scripts, config.options.glob, launchArgs.arguments.confirm, launchArgs.arguments.limit, testmode);
                    startTime = executor.startTime;
                    return [4 /*yield*/, executor.execute(scriptInfo)];
                case 6:
                    exitCode = _e.sent();
                    return [3 /*break*/, 9];
                case 7:
                    error_1 = _e.sent();
                    message = "" + error_1;
                    if (error_1.message)
                        message = error_1.message;
                    if (message !== 'false' && message !== 'Error')
                        logger_1.Logger.error(message);
                    return [3 /*break*/, 9];
                case 8:
                    timespan = process.hrtime(startTime);
                    if (logger_1.Logger.level < 2)
                        logger_1.Logger.info('');
                    logger_1.Logger.info('ExitCode:', exitCode);
                    if (testmode)
                        timespan = [0, 237 * 1000 * 1000];
                    logger_1.Logger.info('Elapsed: ' + prettyTime(timespan, 'ms'));
                    if (!testmode)
                        process.exit(exitCode);
                    return [7 /*endfinally*/];
                case 9: return [2 /*return*/];
            }
        });
    });
}
exports.main = main;
