"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Scripts = void 0;
var common_1 = require("./common");
var Scripts = /** @class */ (function () {
    function Scripts(scripts) {
        this.scripts = scripts;
    }
    Scripts.select = function (scripts, filters, meta) {
        var e_1, _a;
        if (filters === void 0) { filters = null; }
        if (meta === void 0) { meta = null; }
        var length = scripts.length;
        if (!filters)
            filters = [];
        if (!meta)
            meta = { circular: false };
        if (length > 0) {
            if (scripts.some(function (item) { return item.multiple; })) {
                scripts = scripts.filter(Scripts.containsScript.bind(filters));
                if (scripts.length !== length)
                    meta.circular = true;
                var resolvedScripts = Scripts.resolveScripts(scripts);
                return {
                    name: null,
                    inline: false,
                    multiple: true,
                    parameters: {},
                    arguments: [],
                    script: resolvedScripts
                };
            }
            // Sort by number of values and parameters
            scripts = scripts.sort(function (itemA, itemB) { return (Scripts.countValues(itemB.name) - Scripts.countValues(itemA.name)) * 50 + (Scripts.countParams(itemA.name) - Scripts.countParams(itemB.name)); });
            try {
                for (var scripts_1 = __values(scripts), scripts_1_1 = scripts_1.next(); !scripts_1_1.done; scripts_1_1 = scripts_1.next()) {
                    var script = scripts_1_1.value;
                    if (!filters.includes(script.name)) {
                        return script;
                    }
                    else {
                        meta.circular = true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (scripts_1_1 && !scripts_1_1.done && (_a = scripts_1.return)) _a.call(scripts_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        return null;
    };
    Scripts.parse = function (pattern) {
        var args = (0, common_1.stringToArgv)(pattern);
        return {
            command: args.length > 0 ? args[0] : '',
            arguments: args.slice(1)
        };
    };
    Scripts.prototype.find = function () {
        var e_2, _a, e_3, _b, e_4, _c;
        var patterns = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            patterns[_i] = arguments[_i];
        }
        var scripts = [];
        var multiple = patterns.length > 1;
        try {
            for (var patterns_1 = __values(patterns), patterns_1_1 = patterns_1.next(); !patterns_1_1.done; patterns_1_1 = patterns_1.next()) {
                var pattern = patterns_1_1.value;
                var info = Scripts.parse(pattern);
                try {
                    for (var _d = (e_3 = void 0, __values(Object.entries(this.scripts))), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var _f = __read(_e.value, 2), name = _f[0], script = _f[1];
                        var parameters = Scripts.getParameters(name, info.command, multiple);
                        if (parameters !== null) {
                            scripts.push({
                                name: name,
                                inline: false,
                                multiple: multiple,
                                parameters: parameters,
                                arguments: info.arguments,
                                script: script
                            });
                        }
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
                if (scripts.length === 0) {
                    try {
                        for (var _g = (e_4 = void 0, __values(Object.entries(this.scripts))), _h = _g.next(); !_h.done; _h = _g.next()) {
                            var _j = __read(_h.value, 2), name = _j[0], script = _j[1];
                            var parameters = Scripts.getParameters(name, info.command, true);
                            if (parameters !== null) {
                                scripts.push({
                                    name: name,
                                    inline: false,
                                    multiple: true,
                                    parameters: parameters,
                                    arguments: info.arguments,
                                    script: script
                                });
                            }
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_h && !_h.done && (_c = _g.return)) _c.call(_g);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (patterns_1_1 && !patterns_1_1.done && (_a = patterns_1.return)) _a.call(patterns_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return scripts;
    };
    Scripts.containsScript = function (script) {
        var filters = this || [];
        return !filters.some(function (filter) { return Scripts.getParameters(script.name, filter, true) !== null; });
    };
    Scripts.resolveScripts = function (scripts) {
        var e_5, _a;
        var result = [];
        try {
            for (var scripts_2 = __values(scripts), scripts_2_1 = scripts_2.next(); !scripts_2_1.done; scripts_2_1 = scripts_2.next()) {
                var item = scripts_2_1.value;
                if (item.script instanceof Array) {
                    result.push.apply(result, __spreadArray([], __read(item.script), false));
                }
                else {
                    result.push(item.script);
                }
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (scripts_2_1 && !scripts_2_1.done && (_a = scripts_2.return)) _a.call(scripts_2);
            }
            finally { if (e_5) throw e_5.error; }
        }
        return result;
    };
    Scripts.countParams = function (name) {
        var columns = name.split(':');
        return columns.filter(function (item) { return item.startsWith('$'); }).length;
    };
    Scripts.countValues = function (name) {
        var columns = name.split(':');
        return columns.length - columns.filter(function (item) { return item.startsWith('$'); }).length;
    };
    Scripts.getParameters = function (signature, reference, wildcard) {
        var signatureParams = signature.split(':');
        var referenceParams = reference.split(':');
        var parameters = {};
        var defaultParameters = 0;
        if (signatureParams.length < referenceParams.length)
            return null;
        for (var index = 0; index < signatureParams.length; index++) {
            var signatureParam = signatureParams[index];
            var referenceParam = referenceParams[index];
            if (signatureParam.trim().startsWith('$')) {
                var columns = signatureParam.trim().substr(1).split('=');
                var name = columns[0];
                parameters[name] = referenceParam;
                if (!referenceParam) {
                    parameters[name] = columns[1];
                    if (columns[1] !== undefined && referenceParam === undefined)
                        defaultParameters++;
                }
                continue;
            }
            if (wildcard && referenceParam === '*')
                continue;
            if (signatureParam !== referenceParam)
                return null;
        }
        if (signatureParams.length !== referenceParams.length + defaultParameters)
            return null;
        return parameters;
    };
    return Scripts;
}());
exports.Scripts = Scripts;
