"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Process = void 0;
var spawn = require("cross-spawn");
var logger_1 = require("./logger");
var common_1 = require("./common");
var prettyTime = require("pretty-time");
var Process = /** @class */ (function () {
    function Process(childProcess, options) {
        var _this = this;
        this.outputCount = 0;
        this._stdout = '';
        this._stderr = '';
        var startTime = process.hrtime();
        this.pid = childProcess.pid;
        if (logger_1.Logger.level > 1) {
            if (options.testmode) {
                logger_1.Logger.log('Process pid     : ' + common_1.Colors.Yellow + 11111 + common_1.Colors.Normal);
            }
            else {
                logger_1.Logger.log('Process pid     : ' + common_1.Colors.Yellow + childProcess.pid + common_1.Colors.Normal);
            }
            this.showOutputData(childProcess);
        }
        else {
            if (options.testmode)
                this.testOutputData(childProcess);
        }
        this.exitPromise = new Promise(function (resolve, reject) {
            try {
                childProcess.on('close', function (code, signal) {
                    setImmediate(function () {
                        // Proccess all events in event queue, to flush the out streams.
                        if (childProcess.stdout)
                            childProcess.stdout.removeAllListeners('data');
                        if (childProcess.stderr)
                            childProcess.stderr.removeAllListeners('data');
                        if (options.suppress)
                            code = 0;
                        resolve(code);
                    });
                });
                childProcess.on('exit', function (code, signal) {
                    _this._stdout = Process.getStdout(childProcess, options.stdio, _this._stdout);
                    _this._stderr = Process.getStderr(childProcess, options.stdio, _this._stderr);
                    var timespan = process.hrtime(startTime);
                    if (_this.outputCount !== 0)
                        logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                    var extraInfo = options.extraLogInfo ? '  ' + options.extraLogInfo(_this) : '';
                    if (options.testmode) {
                        logger_1.Logger.log('Process exited  : pid=' + 11111 + '  code=' + code + '  signal=' + signal, '  elapsed=4ms' + extraInfo);
                    }
                    else {
                        logger_1.Logger.log('Process exited  : pid=' + childProcess.pid + '  code=' + code + '  signal=' + signal, '  elapsed=' + prettyTime(timespan, 'ms') + extraInfo);
                    }
                    logger_1.Logger.log();
                    logger_1.Logger.log();
                });
                childProcess.on('error', function (error) {
                    _this._stdout = Process.getStdout(childProcess, options.stdio, _this._stdout);
                    _this._stderr = Process.getStderr(childProcess, options.stdio, _this._stderr);
                    var timespan = process.hrtime(startTime);
                    if (_this.outputCount !== 0)
                        logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                    var extraInfo = options.extraLogInfo ? '  ' + options.extraLogInfo(_this) : '';
                    if (options.testmode) {
                        logger_1.Logger.log('Process error   : pid=' + 11111 + ("  code=" + error), '  elapsed=5ms' + extraInfo);
                    }
                    else {
                        logger_1.Logger.log('Process error   : pid=' + childProcess.pid + ("  code=" + error), '  elapsed=' + prettyTime(timespan, 'ms') + extraInfo);
                    }
                    logger_1.Logger.log();
                    logger_1.Logger.log();
                });
            }
            catch (error) {
                if (_this.outputCount !== 0)
                    logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                if (options.testmode) {
                    logger_1.Logger.error('Process failed  : pid=' + 11111 + ("  failed to attach event emitters, " + error + "."));
                }
                else {
                    logger_1.Logger.error('Process failed  : pid=' + childProcess.pid + ("  failed to attach event emitters, " + error + "."));
                }
                logger_1.Logger.log();
                logger_1.Logger.log();
                reject(error);
            }
        });
    }
    Object.defineProperty(Process.prototype, "stdout", {
        get: function () {
            return this._stdout;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Process.prototype, "stderr", {
        get: function () {
            return this._stderr;
        },
        enumerable: false,
        configurable: true
    });
    Process.spawn = function (command, args, options) {
        var _this = this;
        if ((logger_1.Logger.level > 1 || options.testmode) && options) {
            options = __assign({}, options);
            options.stdio = ['inherit', 'pipe', 'pipe'];
        }
        if (!command) {
            return {
                pid: -1,
                stderr: '',
                stdout: '',
                wait: function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                    return [2 /*return*/, 0];
                }); }); }
            };
        }
        var childProcess = spawn(command, args, options);
        if (options.cwd)
            logger_1.Logger.log('Process dir     : ' + common_1.Colors.Green + "'" + options.cwd + "'" + common_1.Colors.Normal);
        return new Process(childProcess, options);
    };
    Process.prototype.wait = function () {
        return this.exitPromise;
    };
    Process.getStdioOption = function (stdio, index) {
        if (typeof stdio === 'string')
            return stdio;
        if (stdio !== undefined && index < stdio.length)
            return stdio[index].toString();
        return '';
    };
    Process.getStdout = function (childProcess, stdio, defaultValue) {
        if (Process.getStdioOption(stdio, 1) === 'pipe') {
            var data = childProcess.stdout.read();
            if (data)
                return data.toString();
        }
        return defaultValue;
    };
    Process.getStderr = function (childProcess, stdio, defaultValue) {
        if (Process.getStdioOption(stdio, 2) === 'pipe') {
            var data = childProcess.stderr.read();
            if (data)
                return data.toString();
        }
        return defaultValue;
    };
    Process.prototype.showOutputData = function (childProcess) {
        var _this = this;
        childProcess.stdout.on('data', function (data) {
            var content = data.toString().trim();
            if (content) {
                _this._stdout += content;
                if (_this.outputCount === 0)
                    logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                logger_1.Logger.log(common_1.Colors.Dim + content + common_1.Colors.Normal);
                _this.outputCount++;
            }
        });
        childProcess.stderr.on('data', function (data) {
            var content = data.toString().trim();
            if (content) {
                _this._stderr += content;
                if (_this.outputCount === 0)
                    logger_1.Logger.log(''.padEnd(process.stdout.columns, '-'));
                logger_1.Logger.log(common_1.Colors.Red + content + common_1.Colors.Normal);
                _this.outputCount++;
            }
        });
    };
    Process.prototype.testOutputData = function (childProcess) {
        var _this = this;
        childProcess.stdout.on('data', function (data) {
            var content = data.toString().trim();
            if (content) {
                _this._stdout += content;
                process.stdout.write(content);
            }
        });
        childProcess.stderr.on('data', function (data) {
            var content = data.toString().trim();
            if (content) {
                _this._stderr += content;
                process.stderr.write(content);
            }
        });
    };
    return Process;
}());
exports.Process = Process;
