"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Variables = void 0;
var Variables = /** @class */ (function () {
    function Variables() {
    }
    Variables.expand = function (text, variables) {
        var e_1, _a;
        var previousText;
        do {
            previousText = text;
            var _loop_1 = function (name, value) {
                var expressions = Variables.createExpressions(name);
                text = text.replace(expressions.pattern1, '$1' + value + '$2');
                text = text.replace(expressions.pattern2, function (substring, args) {
                    var matches = substring.match(expressions.pattern3);
                    var operator = matches[1];
                    var prefix = args.length > 0 ? args[0] : '';
                    return prefix + Variables.evaluateSubstitution(value, operator);
                });
                if (text.match(/([^\\]|^)\$/) === null)
                    return "break";
            };
            try {
                for (var variables_1 = (e_1 = void 0, __values(variables)), variables_1_1 = variables_1.next(); !variables_1_1.done; variables_1_1 = variables_1.next()) {
                    var _b = __read(variables_1_1.value, 2), name = _b[0], value = _b[1];
                    var state_1 = _loop_1(name, value);
                    if (state_1 === "break")
                        break;
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (variables_1_1 && !variables_1_1.done && (_a = variables_1.return)) _a.call(variables_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        } while (text.match(/([^\\]|^)\$/) !== null && text !== previousText);
        return text;
    };
    Variables.createExpressions = function (pattern) {
        return {
            pattern1: new RegExp('([^\\\\]|^)\\$' + pattern + '([^\\w]|$)', 'g'),
            pattern2: new RegExp('([^\\\\]|^)\\$\\{' + pattern + '([%:#/,^].*?)?\\}', 'g'),
            pattern3: new RegExp('\\$\\{' + pattern + '(.*?)\\}')
        };
    };
    Variables.remove = function (text, pattern) {
        var expressions = Variables.createExpressions(pattern);
        text = text.replace(expressions.pattern1, '$1$2');
        text = text.replace(expressions.pattern2, '$1');
        return text;
    };
    Variables.split = function (value, seperators) {
        var e_2, _a;
        var result = [];
        var origin = 0;
        var offset = 0;
        while (origin + offset < value.length) {
            try {
                for (var seperators_1 = (e_2 = void 0, __values(seperators)), seperators_1_1 = seperators_1.next(); !seperators_1_1.done; seperators_1_1 = seperators_1.next()) {
                    var seperator = seperators_1_1.value;
                    if (value.startsWith(seperator, origin + offset)) {
                        result.push({
                            seperator: seperator,
                            value: value.substr(origin, offset)
                        });
                        origin += offset + seperator.length;
                        offset = 0;
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (seperators_1_1 && !seperators_1_1.done && (_a = seperators_1.return)) _a.call(seperators_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            offset++;
        }
        result.push({
            value: value.substr(origin, offset)
        });
        return result;
    };
    Variables.evaluateSubstitution = function (value, operator) {
        if (operator.startsWith(':')) {
            // ${var:num1:num2}	Substring
            var columns = operator.split(':');
            if (columns.length === 3) {
                var index = Number.parseInt(columns[1], 10);
                var length = Number.parseInt(columns[2], 10);
                if (isNaN(index))
                    index = 0;
                if (length < 0)
                    length = value.length + length;
                return value.substr(index, length);
            }
            if (columns.length === 2) {
                var index = Number.parseInt(columns[1], 10);
                return value.substr(index);
            }
            throw new Error('Syntax error in expression: ' + operator);
        }
        if (operator.startsWith('%%')) {
            // ${var%%pattern}	Remove from longest rear (end) pattern
            var seperators = operator
                .substr(2)
                .split('*')
                .filter(function (item) { return item; });
            var matches = Variables.split(value, seperators);
            return matches.length > 0 ? matches[0].value : value;
        }
        if (operator.startsWith('%')) {
            // ${var%%pattern}	Remove from longest rear (end) pattern
            throw new Error('Not implemented');
        }
        if (operator.startsWith('##')) {
            // ${var%%pattern}	Remove from longest rear (end) pattern
            var seperators = operator
                .substr(2)
                .split('*')
                .filter(function (item) { return item; });
            var matches = Variables.split(value, seperators);
            return matches.length > 0 ? matches[matches.length - 1].value : value;
        }
        if (operator.startsWith('#')) {
            // ${var#pattern}	Remove from shortest front pattern
            throw new Error('Not implemented');
        }
        if (operator.startsWith('//')) {
            // ${var//pattern/string}	Find and replace all occurrences
            var columns = operator.split('/');
            if (columns.length === 4) {
                var searchValue = columns[2];
                var replaceValue = columns[3];
                return value.replace(new RegExp(searchValue, 'g'), replaceValue);
            }
            throw new Error('Syntax error in expression: ' + operator);
        }
        if (operator.startsWith('/')) {
            // ${var/pattern/string}	Find and replace (only replace first occurrence)
            var columns = operator.split('/');
            if (columns.length === 3) {
                var searchValue = columns[1];
                var replaceValue = columns[2];
                return value.replace(new RegExp(searchValue), replaceValue);
            }
            throw new Error('Syntax error in expression: ' + operator);
        }
        if (operator.startsWith(',,')) {
            // ${var,,}	Convert all characters to lowercase.
            return value.toLowerCase();
        }
        if (operator.startsWith(',')) {
            // ${var,}	Convert first character to lowercase.
            if (value.length === 0)
                return value;
            return value[0].toLowerCase() + value.substr(1);
        }
        if (operator.startsWith('^^')) {
            // ${var^^}	Convert all character to uppercase..
            return value.toUpperCase();
        }
        if (operator.startsWith('^')) {
            // ${var^}	Convert first character to uppercase.
            if (value.length === 0)
                return value;
            return value[0].toUpperCase() + value.substr(1);
        }
        return value;
    };
    return Variables;
}());
exports.Variables = Variables;
